<?php
/* $Id: template.inc.php 4001 2010-09-17 13:42:41Z denis $ */

function BeginHtml ($title = "", $location = "", $HelpURL = "") {
  global $NO_RIGHTS_MESSAGE, $REMIND_SAVE;
  global $SUB_FOLDER, $ADMIN_TEMPLATE, $ADMIN_PATH, $HTTP_ROOT_PATH;
  global $nc_core;

  $lang = $nc_core->lang->detect_lang(1);
  if ( $lang == 'ru' ) $lang = $nc_core->NC_UNICODE ? "ru_utf8" : "ru_cp1251";
  
	// $title - то, что стоит между тэгами <title>
  $NO_RIGHTS_MESSAGE = NETCAT_MODERATION_ERROR_NORIGHTS;
  
  ?><html lang='<?=MAIN_LANG?>' dir='<?=MAIN_DIR?>'>
  <head>
  <title><?=($title ? $title : "NetCat")?></title>
  <link type='text/css' rel='Stylesheet' href='<?=$ADMIN_TEMPLATE?>css/admin.css'>
  <script type='text/javascript' src='<?=$ADMIN_PATH?>js/lang/<?=$lang?>.js'></script>
  <script type='text/javascript' src='<?=$ADMIN_PATH?>js/lib.js'></script>
  <script type='text/javascript' src='<?=$ADMIN_PATH?>js/forms.js'></script>
  <script type='text/javascript' src='<?=$ADMIN_PATH?>js/sitemap.js'></script>
  <script type='text/javascript' src='<?=$ADMIN_PATH?>js/class_forms.js'></script>
  <script type='text/javascript' src='<?=$ADMIN_PATH?>js/remind_save.js'></script>


  <!-- для диалога генерации альтернативных форм -->
  <script type='text/javascript'>
    var SUB_FOLDER = "<?=$SUB_FOLDER?>";
    var NETCAT_PATH = "<?=$SUB_FOLDER.$HTTP_ROOT_PATH?>";
    var ADMIN_PATH = "<?=$ADMIN_PATH?>";
    var ADMIN_LANG = "<?=MAIN_LANG?>";
    var NC_CHARSET = "<?=$nc_core->NC_CHARSET?>";
    var ICON_PATH = "<?=$ADMIN_TEMPLATE?>" + "img/";
    var CONTROL_CLASS_CLASS_FORMS_ADDFORM_GEN_WARN = "<?=CONTROL_CLASS_CLASS_FORMS_ADDFORM_GEN_WARN?>";
    var CONTROL_CLASS_CLASS_FORMS_EDITFORM_GEN_WARN = "<?=CONTROL_CLASS_CLASS_FORMS_EDITFORM_GEN_WARN?>";
    var CONTROL_CLASS_CLASS_FORMS_QSEARCH_GEN_WARN = "<?=CONTROL_CLASS_CLASS_FORMS_QSEARCH_GEN_WARN?>";
    var CONTROL_CLASS_CLASS_FORMS_SEARCH_GEN_WARN = "<?=CONTROL_CLASS_CLASS_FORMS_SEARCH_GEN_WARN?>";
    var CONTROL_CLASS_CLASS_FORMS_ADDCOND_GEN_WARN = "<?=CONTROL_CLASS_CLASS_FORMS_ADDCOND_GEN_WARN?>";
    var CONTROL_CLASS_CLASS_FORMS_EDITCOND_GEN_WARN = "<?=CONTROL_CLASS_CLASS_FORMS_EDITCOND_GEN_WARN?>";
    var CONTROL_CLASS_CLASS_FORMS_ADDACTION_GEN_WARN = "<?=CONTROL_CLASS_CLASS_FORMS_ADDACTION_GEN_WARN?>";
    var CONTROL_CLASS_CLASS_FORMS_EDITACTION_GEN_WARN = "<?=CONTROL_CLASS_CLASS_FORMS_EDITACTION_GEN_WARN?>";
    var CONTROL_CLASS_CLASS_FORMS_CHECKACTION_GEN_WARN = "<?=CONTROL_CLASS_CLASS_FORMS_CHECKACTION_GEN_WARN?>";
    var CONTROL_CLASS_CLASS_FORMS_DELETEACTION_GEN_WARN = "<?=CONTROL_CLASS_CLASS_FORMS_DELETEACTION_GEN_WARN?>";
  </script>
  
  <?=($GLOBALS["BBCODE"] ? "<script type='text/javascript' src='".$ADMIN_PATH."js/bbcode.js'></script>" : "")?>
  <?php if ($GLOBALS["AJAX_SAVER"]) { ?>
  <script type='text/javascript'>
    var formAsyncSaveEnabled = true;
    var NETCAT_HTTP_REQUEST_SAVING = "<?=str_replace('"', "&quot;", NETCAT_HTTP_REQUEST_SAVING)?>";
    var NETCAT_HTTP_REQUEST_SAVED  = "<?=str_replace('"', "&quot;", NETCAT_HTTP_REQUEST_SAVED )?>";
    var NETCAT_HTTP_REQUEST_ERROR  = "<?=str_replace('"', "&quot;", NETCAT_HTTP_REQUEST_ERROR )?>";
  </script>
  <?php }
  else { ?>
  <script type='text/javascript'>var formAsyncSaveEnabled = false;</script>
  <?php } ?>

  </head>
  <body class='admin_form'>
  <?php

}


function EndHtml () {
  global $UI_CONFIG;

  // saved via XMLHttpRequest
  if ($_POST["NC_HTTP_REQUEST"]) {
    ob_end_clean();
    // [выкинуть ответ]
    if ($GLOBALS["_RESPONSE"]) {
      print nc_array_json($GLOBALS["_RESPONSE"]);
    }
    exit;
  }


  if ($GLOBALS["AJAX_SAVER"]) { ?>
    <div class='save_hint'><?=NETCAT_HTTP_REQUEST_HINT?></div>
  <?php }

  if ( is_object($UI_CONFIG) && method_exists($UI_CONFIG, 'to_json') ) {
    print $UI_CONFIG->to_json();
  }
  
  ?>
  </body>
  </html>
  <?php
}


function GetTemplateDescription ($TemplateID) {
 global $db;
 
 return $db->get_var("SELECT `Description` FROM Template WHERE `Template_ID` = '".intval($TemplateID)."'");
}


function TemplateChildrenNumber ($TemplateID) {
  global $db;
  
  return $db->get_var("SELECT count(Template_ID) FROM `Template` WHERE `Parent_Template_ID` = '".intval($TemplateID)."'");
}

?>
