<?php
/* $Id: function.inc.php 4083 2010-10-27 14:57:04Z denis $ */

/*
 * Скопируем поля из основного шаблона во вновь созданный
 */
function InsertFieldsFromBaseClass($BaseClassID,$NewClassID){
	global $db;

  $BaseClassID += 0;
  $NewClassID += 0;

  $db->query("INSERT INTO `Field` (`Class_ID`, `Field_Name`, `Description`, `TypeOfData_ID`, `Format`, `NotNull`, `Priority`, `DoSearch`, `DefaultState`, `Inheritance`, `System_Table_ID`, `TypeOfEdit_ID`)
    SELECT ".$NewClassID.", `Field_Name`, `Description`, `TypeOfData_ID`, `Format`, `NotNull`, `Priority`, `DoSearch`, `DefaultState`, `Inheritance`, `System_Table_ID`, `TypeOfEdit_ID`
      FROM `Field`
      WHERE `Class_ID` = '".$BaseClassID."'");

  $Result = $db->get_results("SELECT `Field_ID` FROM `Field` WHERE `Class_ID` = '".$NewClassID."'");
  if ( !empty($Result) ) {
    foreach( $Result as $Array ) {
      ColumnInMessage($Array->Field_ID, 1, $db);
    }
  }
}

/*
 * Скопируем поля действий из основного шаблона во вновь созданный
 */
function InsertActionsFromBaseClass($BaseClassID,$NewClassID){
	global $nc_core, $db;

  $BaseClassID += 0;
  $NewClassID += 0;

	$ret = false;

  $Result = $db->get_results("SELECT `AddTemplate`, `EditTemplate`, `AddActionTemplate`, `EditActionTemplate`, `SearchTemplate`, `FullSearchTemplate`, `SubscribeTemplate`, `AddCond`, `EditCond`, `SubscribeCond`, `CheckActionTemplate`, `DeleteActionTemplate`
    FROM `Class`
    WHERE `Class_ID` = '".$BaseClassID."'", ARRAY_A);

  $q = array();

  if ( !empty($Result) ) {
		foreach( $Result as $Array ) {
			foreach ($Array as $key => $val) {
				if($val!= "") {
          $q[] = "`".$key."` = '".addslashes($val)."'";
          $ret = true;
				}
			}
		}
	}


  if ($ret) {
    $db->query("UPDATE `Class` SET ".join(',', $q). " WHERE `Class_ID` = '".$NewClassID."';");

    $ClassTemplate = $db->get_var("SELECT `ClassTemplate` FROM `Class` WHERE `Class_ID` = '".$NewClassID."'");

    // execute core action
    if (!$ClassTemplate) {
      $nc_core->event->execute("updateClass", $NewClassID);
    }
    else {
      // main class, template class
      $nc_core->event->execute("updateClassTemplate", $ClassTemplate, $NewClassID);
    }
  }
}

##############################################
# Вывод списка групп шаблонов
##############################################
function ClassGroupList()
{
	global $db;

	if ( ($Result = $db->get_results("SELECT DISTINCT `Class_Group` FROM `Class` WHERE `System_Table_ID` = 0 AND `ClassTemplate` = 0 ORDER BY `Class_Group` ASC")) )
	{
		?>
 		<form method=post action=index.php>
		<table border=0 cellpadding=0 cellspacing=0 width=100%><tr><td bgcolor=cccccc>

		<table border=0 cellpadding=4 cellspacing=1 width=100%>
		<tr>
		<td bgcolor=eeeeee><font size=-2><b><?=CONTROL_CLASS_CLASS_GROUPS?></b></td>
		</tr>
		<?

		foreach( $Result as $Array )
		{
			print "<tr>";
			print "<td bgcolor=white><a href=\"index.php?phase=1&ClassGroup=".urlencode($Array->Class_Group)."\">".$Array->Class_Group."</a></td>";
			print "</tr>";
		}
		?>
		</table>
		</td></tr></table><br>
		<?
	}
	else
	{
		nc_print_status(CONTROL_CLASS_NONE, 'info');
	}
	?>
	<a href=index.php?phase=10><b><?=CONTROL_CLASS_ADD?></a>
	<?
}


##############################################
# Вывод списка шаблонов
##############################################
function ClassList($Class_Group = false)
{
	global $db, $ADMIN_PATH, $ADMIN_TEMPLATE, $UI_CONFIG;

	if ($Class_Group)
	{
		$select = "SELECT Class_ID, Class_Name, IF(AddTemplate<>'' OR AddCond<>'' OR AddActionTemplate<>'',1,0) AS IsAdd, IF(EditTemplate<>'' OR EditCond<>'' OR EditActionTemplate<>'' OR CheckActionTemplate<>'',1,0) AS IsEdit, IF(SearchTemplate<>'' OR FullSearchTemplate<>'',1,0) AS IsSearch, IF(SubscribeTemplate<>'' OR SubscribeCond<>'',1,0) AS IsSubscribe, IF( DeleteActionTemplate<>'' OR DeleteTemplate <> '' OR DeleteCond <> '', 1, 0) as IsDelete from Class where md5(Class_Group)='".$Class_Group."' AND System_Table_ID=0 AND ClassTemplate=0 order by Class_ID";
	}
	else
	{
		$select = "SELECT Class_ID, Class_Name, IF(AddTemplate<>'' OR AddCond<>'' OR AddActionTemplate<>'',1,0) AS IsAdd, IF(EditTemplate<>'' OR EditCond<>'' OR EditActionTemplate<>'' OR CheckActionTemplate<>'' OR DeleteActionTemplate<>'',1,0) AS IsEdit, IF(SearchTemplate<>'' OR FullSearchTemplate<>'',1,0) AS IsSearch, IF(SubscribeTemplate<>'' OR SubscribeCond<>'',1,0) AS IsSubscribe, Class_Group from Class where System_Table_ID=0 AND ClassTemplate=0 order by Class_ID";
	}

	if ( ($Result = $db->get_results($select)) )
	{
		?>
		<form method=post action=index.php>
 		<table border=0 cellpadding=0 cellspacing=0 width=100%><tr><td bgcolor=cccccc>

 		<table border=0 cellpadding=4 cellspacing=1 width=100%>
 		<tr>
 		<td bgcolor=eeeeee><font size=-2><b>ID</td>
 		<td bgcolor=eeeeee width=45%><font size=-2><b><?=CONTROL_CLASS_CLASS?></b></td>
 		<? if(!$Class_Group) echo("<td bgcolor=eeeeee width=45%><font size=-2><b>".CONTROL_USER_GROUP."</b></td>"); ?>
 		<td bgcolor=eeeeee align=center><font size=-2><b><?=CONTROL_CLASS_ACTIONS?></b></td>
 		<td bgcolor=eeeeee align=center><font size=-2><b><?=CONTROL_CLASS_FIELDS?></b></td>

 		<td bgcolor=eeeeee align=center><img src='<?=$ADMIN_TEMPLATE?>img/i_delete.gif' width='16' height='16' alt='<?=CONTROL_CLASS_DELETE?>'></td>
 		</tr>
 		<?
 		foreach( $Result as $Array )
		{
			print "<tr>";
			print "<td bgcolor=white><font size=-2><b>".$Array->Class_ID."</td>";
			print "<td bgcolor=white><a href=\"index.php?phase=4&ClassID=".$Array->Class_ID.($Class_Group?'&ClassGroup='.md5($Class_Group):'')."\">".$Array->Class_Name."</a></td>";
			if(!$Class_Group) print "<td width='1%' bgcolor=white><font size=-2><a href=\"index.php?phase=1&ClassGroup=".md5($Array->Class_Group)."\">".$Array->Class_Group."</a></td>";
			print "<td bgcolor=white align=center><font size=-2><nobr>
			     <a href=\"index.php?phase=8&ClassID=".$Array->Class_ID."&myaction=1".($Class_Group?'&ClassGroup='.urlencode($Class_Group):'')."\">".(!$Array->IsAdd?"<font color=gray>":"")."".CONTROL_CLASS_ACTIONS_ADD."</a>&nbsp;&nbsp;
			     <a href=\"index.php?phase=8&ClassID=".$Array->Class_ID."&myaction=2".($Class_Group?'&ClassGroup='.urlencode($Class_Group):'')."\">".(!$Array->IsEdit?"<font color=gray>":"")."".CONTROL_CLASS_ACTIONS_EDIT."</a>&nbsp;&nbsp;
			     <a href=\"index.php?phase=8&ClassID=".$Array->Class_ID."&myaction=5".($Class_Group?'&ClassGroup='.urlencode($Class_Group):'')."\">".(!$Array->IsDelete?"<font color=gray>":"")."".CONTROL_CLASS_ACTIONS_DELETE."</a>&nbsp;&nbsp;
			     <a href=\"index.php?phase=8&ClassID=".$Array->Class_ID."&myaction=3".($Class_Group?'&ClassGroup='.urlencode($Class_Group):'')."\">".(!$Array->IsSearch?"<font color=gray>":"")."".CONTROL_CLASS_ACTIONS_SEARCH."</a>&nbsp;&nbsp;
			     <a href=\"index.php?phase=8&ClassID=".$Array->Class_ID."&myaction=4".($Class_Group?'&ClassGroup='.urlencode($Class_Group):'')."\">".(!$Array->IsSubscribe?"<font color=gray>":"")."".CONTROL_CLASS_ACTIONS_MAIL."</a></nobr></td>";

			print "<td bgcolor=white align=center><font size=-2><a href=\"".$ADMIN_PATH."field/?ClassID=".$Array->Class_ID."\"><img border=0 width=16 height=16 alt='".CONTROL_CLASS_FIELDSLIST."' src=".$ADMIN_PATH."images/list.gif></a></td>";
			print "<td bgcolor=white align=center><INPUT TYPE=CHECKBOX NAME=\"Delete".$Array->Class_ID."\" VALUE=".$Array->Class_ID."></td>";
			print "</tr>";
		}
		?>
		</table>
		</td></tr></table><br>
		<?
	}
	else
	{
		nc_print_status(CONTROL_CLASS_NONE, 'info');
	}
/*
	?>
	<table border=0 cellpadding=0 cellspacing=0 width=100%><tr><td><a href=index.php?phase=10><b><?=CONTROL_CLASS_ADD?></a></td>
	<?
*/
	if ($Array)
	{
       $UI_CONFIG->actionButtons[] = array("id" => "addClass",
                                           "caption" => CONTROL_CLASS_FUNCS_SHOWCLASSLIST_ADDCLASS,
                                           "action" => "urlDispatcher.load('dataclass.add($Class_Group)')",
                                           "align" => "left");
       $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                           "caption" => NETCAT_ADMIN_DELETE_SELECTED,
                                           "action" => "mainView.submitIframeForm()");
/*
		?>
		<td align=right><input class=s type=reset value='<?=CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_CANCEL?>'> <input type=submit class=s value='<?=CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_SAVE?>'></td>
		<?
*/
	}
/*
	?>
	</tr></table>
	<?
*/
	if ($Array)
	{
		if ($Class_Group) print "<input type='hidden' name='ClassGroup' value='$Class_Group'>";
		?>
 		<input type=hidden name=phase value=6>
		<input type='submit' class='hidden'>
 		</form>
 		<?
 	}
}


function ClassTemplatesList($Class_ID = 0) {
	global $UI_CONFIG;

  // system superior object
  $nc_core = nc_Core::get_object();

  // system db object
  if ( is_object($nc_core->db) ) $db = &$nc_core->db;

  $result = $nc_core->db->get_results("SELECT `Class_ID`, `Class_Name`,
    IF(`AddTemplate` <> '' OR `AddCond` <> '' OR `AddActionTemplate` <> '', 1, 0) AS IsAdd,
    IF(`EditTemplate` <> '' OR `EditCond` <> '' OR `EditActionTemplate` <> '' OR `CheckActionTemplate` <> '', 1, 0) AS IsEdit,
    IF(`SearchTemplate` <> '' OR `FullSearchTemplate` <> '', 1, 0) AS IsSearch,
    IF(`SubscribeTemplate` <> '' OR `SubscribeCond` <> '', 1, 0) AS IsSubscribe,
    IF(`DeleteActionTemplate` <> '' OR `DeleteTemplate` <> '' OR `DeleteCond` <> '', 1, 0) as IsDelete,
    IF( `Type` <> '', `Type`, 'useful') AS `Type`
    FROM `Class`
    WHERE ".($Class_ID ? "`ClassTemplate` = '".$Class_ID."'" : "`ClassTemplate` != 0").
    "ORDER BY `Class_ID`"); 

	if ( !empty($result) ) {
		?>
		<form method='post' action='index.php'>
 		<table border='0' cellpadding='0' cellspacing='0' width='100%'>
    <tr>
    <td bgcolor='#CCCCCC'>
      <table border='0' cellpadding='4' cellspacing='1' width='100%'>
      <tr>
        <td bgcolor='#EEEEEE'>
          <font size='-2'><b>ID</b></font>
        </td>
        <td bgcolor='#EEEEEE' width='45%'>
          <font size='-2'><b><?=CONTROL_CLASS_CLASS_TEMPLATE?></b></font>
        </td>
        <td bgcolor='#EEEEEE' align='center'>
          <font size='-2'><b><?=CONTROL_CLASS_COMPONENT_TEMPLATE_TYPE?></b></font>
        </td>
        <td bgcolor='#EEEEEE' align='center'>
          <font size='-2'><b><?=CONTROL_CLASS_ACTIONS?></b></font>
        </td>
        <td bgcolor='#EEEEEE' align='center'>
          <img src='<?=$nc_core->ADMIN_TEMPLATE?>img/i_delete.gif' width='16' height='16' alt='<?=CONTROL_CLASS_DELETE?>'/>
        </td>
      </tr>
      <?php
      foreach($result as $Array) {
        print "<tr>";
        print "<td bgcolor='#FFFFFF'><font size='-2'><b>".$Array->Class_ID."</b></font></td>";
        print "<td bgcolor='#FFFFFF'><a href='index.php?phase=16&amp;ClassID=".$Array->Class_ID."'>".$Array->Class_Name."</a></td>";
        print "<td bgcolor='#FFFFFF' align='center'><font size='-2'>".constant("CONTROL_CLASS_COMPONENT_TEMPLATE_TYPE_".strtoupper($Array->Type))."</font></td>";
        print "<td bgcolor='#FFFFFF' align='center'><font size='-2'><nobr>
          <a href='index.php?phase=22&amp;ClassID=".$Array->Class_ID."&amp;myaction=1'>".(!$Array->IsAdd ? "<font color='gray'>" : "").CONTROL_CLASS_ACTIONS_ADD.(!$Array->IsAdd ? "</font>" : "")."</a>&nbsp;&nbsp;
          <a href='index.php?phase=22&amp;ClassID=".$Array->Class_ID."&amp;myaction=2'>".(!$Array->IsEdit ? "<font color='gray'>" : "").CONTROL_CLASS_ACTIONS_EDIT.(!$Array->IsEdit ? "</font>" : "")."</a>&nbsp;&nbsp;
          <a href='index.php?phase=22&amp;ClassID=".$Array->Class_ID."&amp;myaction=5'>".(!$Array->IsDelete ? "<font color='gray'>" : "").CONTROL_CLASS_ACTIONS_DELETE.(!$Array->IsDelete ? "</font>" : "")."</a>&nbsp;&nbsp;
          <a href='index.php?phase=22&amp;ClassID=".$Array->Class_ID."&amp;myaction=3'>".(!$Array->IsSearch ? "<font color='gray'>" : "").CONTROL_CLASS_ACTIONS_SEARCH.(!$Array->IsSearch ? "</font>" : "")."</a>&nbsp;&nbsp;
          <a href='index.php?phase=22&amp;ClassID=".$Array->Class_ID."&amp;myaction=4'>".(!$Array->IsSubscribe ? "<font color='gray'>" : "").CONTROL_CLASS_ACTIONS_MAIL.(!$Array->IsSubscribe ? "</font>" : "")."</a></nobr></font></td>";
        print "<td bgcolor='#FFFFFF' align='center'><input type='checkbox' name=\"Delete".$Array->Class_ID."\" value='".$Array->Class_ID."'></td>";
        print "</tr>";
      }
      ?>
      </table>
		</td>
    </tr>
    </table>
    <br/>
		<?php
	}
	else {
		nc_print_status(CONTROL_CLASS_CLASS_TEMPLATE_ERROR_NOT_FOUND, 'info');
	}

	if ($Array) {
    $UI_CONFIG->actionButtons[] = array(
      "id" => "submit",
      "align" => "left",
      "caption" => CONTROL_CLASS_CLASS_TEMPLATE_ADD,
      "location" => "classtemplate.add(".$Class_ID.")"
    );
    $UI_CONFIG->actionButtons[] = array(
      "id" => "submit",
      "caption" => NETCAT_ADMIN_DELETE_SELECTED,
      "action" => "mainView.submitIframeForm()"
    );
	}

	if ($Array) {
		?>
 		<input type='hidden' name='phase' value='18'>
    <input type='hidden' name='ClassTemplate' value='<?=$Class_ID?>'>
		<input type='submit' class='hidden'>
 		</form>
 		<?php
 	}
}


/*
 * Component add/edit form
 *
 * @param int component ID (0 if action "add")
 * @param string action, for example "index.php"
 * @param int phase from index.php
 * @param int operation type, 1 - insert, 2 - update, 3 - update for System_Table (ClassID==SystemTableID)
 *
 * @return HTML code into the output buffer
 */
function ClassForm ($ClassID, $action, $phase, $type, $BaseClassID) {
	global $ROOT_FOLDER, $ClassGroup, $ADMIN_PATH, $UI_CONFIG;

  // system superior object
  $nc_core = nc_Core::get_object();

  // system db object
  if ( is_object($nc_core->db) ) $db = &$nc_core->db;

  // compile main MySQL query
	$select = "SELECT `Class_ID`, `Class_Name`, `DaysToHold`, `AllowTags`, `NL2BR`, `System_Table_ID`, ";
	$select.= "`FormPrefix`, `FormSuffix`, `RecordTemplate`, `RecordsPerPage`, ";
	$select.= "`SortBy`, `RecordTemplateFull`, `TitleTemplate`, `Settings`, `Class_Group`, `UseCaptcha`, `CustomSettingsTemplate`, `ClassDescription`, `ClassTemplate`, `Type` ";
  if ( $nc_core->modules->get_by_keyword("cache") ) $select.= ", `CacheForUser`";
	$select.= "FROM `Class` WHERE ";

	if ($BaseClassID) {
		$type = 2;
		$ClassID = $BaseClassID;
	}
	?>
	<form method='post' id='ClassForm' action='<?= $action ?>'>
 	<?
	if ($type == 1)	{
	  if ( !$nc_core->input->fetch_post() ) {
	    if (!$Array->Class_Name) $Array->Class_Name = CONTROL_CLASS_NEWCLASS;
	    if (!$Array->FormPrefix) $Array->FormPrefix = "\$f_AdminCommon";
	    if (!$Array->RecordTemplate) $Array->RecordTemplate = "\$f_AdminButtons";
	    if (!$Array->RecordsPerPage) $Array->RecordsPerPage = "20";
	    if (!$Array->Class_Group) $Array->Class_Group = $db->get_var("SELECT `Class_Group` FROM `Class` WHERE md5(`Class_Group`) = '".$ClassGroup."'");
	  }
    else {
	    $Array->Class_Name = $nc_core->input->fetch_post('Class_Name');
	    $Array->Class_Group = $nc_core->input->fetch_post('Class_Group');
	    $Array->Class_Group_New = $nc_core->input->fetch_post('Class_Group_New');
	    $Array->FormPrefix = $nc_core->input->fetch_post('FormPrefix');
	    $Array->FormSuffix = $nc_core->input->fetch_post('FormSuffix');
	    $Array->RecordTemplate = $nc_core->input->fetch_post('RecordTemplate');
	    $Array->RecordsPerPage = $nc_core->input->fetch_post('RecordsPerPage');
	    $Array->SortBy = $nc_core->input->fetch_post('SortBy');
	    $Array->AllowTags = $nc_core->input->fetch_post('AllowTags');
	    $Array->NL2BR = $nc_core->input->fetch_post('NL2BR');
	    $Array->RecordTemplateFull = $nc_core->input->fetch_post('RecordTemplateFull');
	    $Array->TitleTemplate = $nc_core->input->fetch_post('TitleTemplate');
	    $Array->Settings = $nc_core->input->fetch_post('Settings');
	    $Array->UseCaptcha = $nc_core->input->fetch_post('UseCaptcha');
      if ( $nc_core->modules->get_by_keyword("cache") ) {
        $Array->CacheForUser = $nc_core->input->fetch_post('CacheForUser');
      }
	    $Array->CustomSettingsTemplate = $nc_core->input->fetch_post('CustomSettingsTemplate');
	    $Array->ClassDescription = $nc_core->input->fetch_post('ClassDescription');
	  }
	}
  elseif ($type == 2) {
		$select .= " `Class_ID` = '".$ClassID."'";
		$Array = $db->get_row($select);
		if ($ClassGroup) {
			$Array->Class_Group = $db->get_var("SELECT `Class_Group` FROM `Class` WHERE md5(`Class_Group`) = '".$ClassGroup."'");
		}
		if ($phase == 5) {
			if ($ClassGroup) $Array->Class_Group = $ClassGroup;
		}
		if (!$Array) nc_print_status(CONTROL_CLASS_ERRORS_DB, 'error');
	}
  elseif ($type == 3) {
		$select .= " `System_Table_ID` = '".$ClassID."' AND `ClassTemplate` = 0";
		$Array = $db->get_row($select);
		if (!$Array) nc_print_status(CONTROL_CLASS_ERRORS_DB, 'error');
	}

  if ($type==1 or $type==2) {
    ?>
    <fieldset>
    <legend><?=CONTROL_CLASS_INFO_ADDSLASHES?></legend>
    <br/>
    <?php
      echo  "<font color='gray'>".CONTROL_CLASS_CLASS_NAME.":</font><br/>";
      echo  "<input type='text' name='ClassName' size='50' value=\"".htmlspecialchars($Array->Class_Name)."\"><br/><br/>";

      // if not component template - show groups
      if ( !($Array->ClassTemplate || $phase==15) ) {
        $classGroups = $db->get_col("SELECT DISTINCT `Class_Group` FROM `Class`");
        if ( !empty($classGroups) ) {
          echo CONTROL_USER_GROUP.":<br/><select name='Class_Group' style='width:auto;'>\n";
          foreach ($classGroups  as $Class_Group) {
            if ($Array->Class_Group == $Class_Group) {
              echo("\t<option value='".$Class_Group."' selected='selected'>".$Class_Group."</option>\n");
            }
            else {
              echo("\t<option value='".$Class_Group."'>".$Class_Group."</option>\n");
            }
          }
          echo "</select>&nbsp;&nbsp;&nbsp;";
        }
        unset($classGroups);

        echo CONTROL_CLASS_NEWGROUP."&nbsp;&nbsp;&nbsp;<input type='text' name='Class_Group_New' size='25' maxlength='64' value='".htmlspecialchars($Array->Class_Group_New)."'><br/><br/>";
      }
      else {
        echo CONTROL_USER_GROUP.": <b>".CONTROL_CLASS_CLASS_TEMPLATE_GROUP."</b>";
        echo "<input type='hidden' name='Class_Group' value='".CONTROL_CLASS_CLASS_TEMPLATE_GROUP."'>";
      }

      if ( $Array->ClassTemplate ) {
        if ( !$Array->Type ) $Array->Type = 'useful';
        echo "<br/> Тип:  ";
        echo '<b>'.constant("CONTROL_CLASS_COMPONENT_TEMPLATE_TYPE_".strtoupper($Array->Type)).'</b>';
      }
    ?>
    </fieldset>
    <br/>
    <?php
  }

 	echo "<table border='0' cellpadding='6' cellspacing='0' width='100%' bgcolor='#F3F3F3'><tr><td colspan='2'>".
 	  "<div id='classDescriptionOff' style='cursor: pointer;' onclick='this.style.display=\"none\";document.getElementById(\"classDescriptionOn\").style.display=\"\";'>".
 	    "<font color='gray'> &#x25BA; ".CONTROL_CLASS_CLASS_DESCRIPTION."</font>".
 	  "</div>".
 	  "<div id='classDescriptionOn' style='display: none'>".
	    "<font color='gray' style='cursor: pointer;' onclick='document.getElementById(\"classDescriptionOn\").style.display=\"none\";document.getElementById(\"classDescriptionOff\").style.display=\"\";'> &#x25BC; ". CONTROL_CLASS_CLASS_DESCRIPTION. ":</font>".
	    "<br/><textarea id='ClassDescription' wrap='OFF' rows='8' cols='60' name='ClassDescription'>".
   	   htmlspecialchars($Array->ClassDescription).
   	 "</textarea></div></td></tr></table><br/>";
	?>

  <b><font color='gray'><?=CONTROL_CLASS_CLASS_OBJECTSLIST?></font></b>
	<table border='0' cellpadding='6' cellspacing='0' width='100%' bgcolor='#F3F3F3'>
	<tr>
    <td>
      <a name='ListPrefixLink' href='#ListPrefix' onclick="window.open('<?=$ADMIN_PATH?>class/index.php?phase=12&formtype=class&window=opener&form=ClassForm&textarea=ListPrefix<?=(($type != 3)?"&classid=$ClassID&systemclassid=0":"&classid=0&systemclassid=$ClassID")?>','LIST','top=50, left=100,directories=no,height=600,location=no,menubar=no,resizable=no,scrollbars=yes,status=yes,toolbar=no,width=400')"><?=CONTROL_CLASS_CLASS_SHOW_VAR_FUNC_LIST?></a><br/>
      <div class='resize_block'> <a class='textarea_shrink' href='#ListPrefix' > &#x25BC; </a><a class='textarea_grow' href='#ListPrefix'> &#x25B2; </a></div>
      <font color='gray'><?=CONTROL_CLASS_CLASS_OBJECTSLIST_PREFIX?>:</font><br/>
      <textarea id='ListPrefix' wrap='OFF' rows='10' cols='60' name='FormPrefix'><?=htmlspecialchars($Array->FormPrefix)?></textarea>
    </td>
  </tr>
	<tr>
    <td>
      <a name='ListBodyLink' href='#ListBody' onclick="window.open('<?=$ADMIN_PATH?>class/index.php?phase=12&formtype=class&window=opener&form=ClassForm&textarea=ListBody<?=(($type != 3)?"&classid=$ClassID&systemclassid=0":"&classid=0&systemclassid=$ClassID")?>','LIST','top=50, left=100,directories=no,height=600,location=no,menubar=no,resizable=no,scrollbars=yes,status=yes,toolbar=no,width=400')"><?=CONTROL_CLASS_CLASS_SHOW_VAR_FUNC_LIST?></a><br/>
      <div class='resize_block'> <a class='textarea_shrink' href='#ListBody' > &#x25BC; </a><a class='textarea_grow' href='#ListBody'> &#x25B2; </a></div>
      <font color='gray'><?=CONTROL_CLASS_CLASS_OBJECTSLIST_BODY?>:</font><br/>
      <textarea id='ListBody' wrap='OFF' rows='10' cols='60' name='RecordTemplate'><?=htmlspecialchars($Array->RecordTemplate)?></textarea>
    </td>
  </tr>
	<tr>
    <td>
      <a name='ListSuffixLink' href='#ListSuffix' onclick="window.open('<?=$ADMIN_PATH?>class/index.php?phase=12&formtype=class&window=opener&form=ClassForm&textarea=ListSuffix<?=(($type != 3)?"&classid=$ClassID&systemclassid=0":"&classid=0&systemclassid=$ClassID")?>','LIST','top=50, left=100,directories=no,height=600,location=no,menubar=no,resizable=no,scrollbars=yes,status=yes,toolbar=no,width=400')"><?=CONTROL_CLASS_CLASS_SHOW_VAR_FUNC_LIST?></a><br/>
      <div class='resize_block'> <a class='textarea_shrink' href='#ListSuffix' > &#x25BC; </a><a class='textarea_grow' href='#ListSuffix'> &#x25B2; </a></div>
      <font color='gray'><?=CONTROL_CLASS_CLASS_OBJECTSLIST_SUFFIX?>:</font><br/>
      <textarea id='ListSuffix' wrap='OFF' rows='10' cols='60' name='FormSuffix'><?=htmlspecialchars($Array->FormSuffix)?></textarea>
    </TD>
  </TR>
	<tr>
    <td>
      <font color='gray'><?=CONTROL_CLASS_CLASS_OBJECTSLIST_SHOW?> <input type='text' name='RecordsPerPage' SIZE='4' maxlength='255' value="<?=htmlspecialchars($Array->RecordsPerPage)?>"> <?=CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ?>
    </td>
  </tr>
	<tr>
    <td>
      <font color='gray'><a name='SortByLink' href='#SortBy' onclick="window.open('<?=$ADMIN_PATH?>class/index.php?phase=12&formtype=classinput&window=opener&form=ClassForm&textarea=SortBy<?=(($type != 3)?"&classid=$ClassID&systemclassid=0":"&classid=0&systemclassid=$ClassID")?>','LIST','top=50, left=100,directories=no,height=600,location=no,menubar=no,resizable=no,scrollbars=yes,status=yes,toolbar=no,width=400')"><?=CONTROL_CLASS_CLASS_SHOW_VAR_LIST?></a><br><?=CONTROL_CLASS_CLASS_OBJECTSLIST_SORT?>*:<br/><input id='SortBy' type='text' name='SortBy' size='50' maxlength='255' value="<?=htmlspecialchars($Array->SortBy)?>"><br/>
      * <?=CONTROL_CLASS_CLASS_OBJECTSLIST_SORTNOTE?>
    </td>
  </tr>
	</table>
  <br/>

	<b><font color='gray'><?=CONTROL_CLASS_CLASS_OBJECTVIEW?></font></b>
	<table border=0 cellpadding=6 cellspacing=0 width=100% bgcolor=#F3F3F3>
	<tr>
    <td>
      <font color='gray'><?=CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ_PAGETITLE?>:<br><input type='text' name='TitleTemplate' size='50' maxlength='255' value="<?=htmlspecialchars($Array->TitleTemplate)?>">
    </td>
  </tr>
	<tr>
    <td><a name='PageBodyLink' href='#PageBody' onclick="window.open('<?=$ADMIN_PATH?>class/index.php?phase=12&formtype=class&window=opener&form=ClassForm&textarea=PageBody<?=(($type != 3)?"&classid=$ClassID&systemclassid=0":"&classid=0&systemclassid=$ClassID")?>','LIST','top=50, left=100,directories=no,height=600,location=no,menubar=no,resizable=no,scrollbars=yes,status=yes,toolbar=no,width=400')"><?=CONTROL_CLASS_CLASS_SHOW_VAR_FUNC_LIST?></a><br/>
      <div class='resize_block'> <a class='textarea_shrink' href='#PageBody' > &#x25BC; </a><a class='textarea_grow' href='#PageBody'> &#x25B2; </a></div>
      <font color='gray'><?=CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ_PAGEBODY?>:</font><br>
      <textarea id='PageBody' wrap='OFF' rows='10' cols='60' name='RecordTemplateFull'><?=htmlspecialchars($Array->RecordTemplateFull)?></textarea>
    </td>
  </tr>
	</table>
  <br/>

  <?php if ( $nc_core->modules->get_by_keyword("cache") ): ?>
  <b><font color=gray><?=CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ_CACHE?></font></b>
	<table border='0' cellpadding='6' cellspacing='0' width='100%' bgcolor='#F3F3F3'>
  <tr>
    <td>
      <font color='gray'><?=CONTROL_CLASS_CACHE_FOR_AUTH?>*:</font><br/>
      <select name='CacheForUser'>
        <option value='0'<?=(!$Array->CacheForUser ? " selected" : "")?>><?=CONTROL_CLASS_CACHE_FOR_AUTH_NONE?></option>
        <option value='1'<?=($Array->CacheForUser==1 ? " selected" : "")?>><?=CONTROL_CLASS_CACHE_FOR_AUTH_USER?></option>
        <option value='2'<?=($Array->CacheForUser==2 ? " selected" : "")?>><?=CONTROL_CLASS_CACHE_FOR_AUTH_GROUP?></option>
      </select><br/>
      <font color='gray'>
      * <?=CONTROL_CLASS_CACHE_FOR_AUTH_DESCRIPTION?>
      </font>
    </td>
  </tr>
  </table>
	<br/>
  <?php endif; ?>

	<b><font color=gray><?=CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ_DOPL?></font></b>
	<table border='0' cellpadding='6' cellspacing='0' width='100%' bgcolor='#F3F3F3'>
	<tr>
    <td colspan='2'>
      <font color='gray'><input type='checkbox' id='tags' name='AllowTags' <?=($Array->AllowTags ? "checked" : "")?> value='1'> <label for='tags'><?=CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ_HTML?></label>
    </td>
  </tr>
	<tr>
    <td colspan='2'>
      <font color='gray'><input type='checkbox' id='br' name='NL2BR' <?=($Array->NL2BR ? "checked" : "")?> value='1'> <label for='br'><?=CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ_BR?></label>
    </td>
  </tr>
	<tr>
    <td colspan='2'>
      <font color='gray'><input type='checkbox' id='captcha' name='UseCaptcha' <?=($Array->UseCaptcha ? "checked" : "")?> value='1'> <label for='captcha'><?=CONTROL_CLASS_USE_CAPTCHA?></label>
    </td>
  </tr>
 	<tr>
    <td colspan='2'>
      <a name='SettingsLink' href='#Settings' onclick="window.open('<?=$ADMIN_PATH?>class/index.php?phase=12&formtype=class&window=opener&form=ClassForm&textarea=Settings<?=($type!=3 ? "&classid=".$ClassID."&systemclassid=0" : "&classid=0&systemclassid=".$ClassID)?>','LIST','top=50, left=100,directories=no,height=600,location=no,menubar=no,resizable=no,scrollbars=yes,status=yes,toolbar=no,width=400'); return false;"><?=CONTROL_CLASS_CLASS_SHOW_VAR_FUNC_LIST?></a><br/>
      <?php print_resizeblock("Settings"); ?>
      <font color='gray'><?=CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ_SYSTEM?>:</font><br/><textarea id='Settings' wrap='OFF' rows='8' cols='60' name='Settings'><?=htmlspecialchars($Array->Settings)?></textarea>
    </td>
  </tr>
  <tr>
    <td colspan='2'>
      <?php if ( !$Array->ClassTemplate || $Array->Type == 'useful') : ?>
      <div id='cstOff' style='cursor: pointer;' onclick='this.style.display="none";document.getElementById("cstOn").style.display="";'>
        <font color='gray'> &#x25BA; <?=CONTROL_CLASS_CUSTOM_SETTINGS_TEMPLATE?></font>
      </div>
      <div id='cstOn' style='display: none'>
        <font color='gray' style='cursor: pointer;' onclick='document.getElementById("cstOn").style.display="none";document.getElementById("cstOff").style.display="";'> &#x25BC; <?=CONTROL_CLASS_CUSTOM_SETTINGS_TEMPLATE?>:</font>
        <br/><textarea id='CustomSettings' wrap='OFF' rows='8' cols='60' name='CustomSettingsTemplate'><?=htmlspecialchars($Array->CustomSettingsTemplate)?></textarea>
      </div>
      <?php
      else  :
       echo CONTROL_CLASS_CUSTOM_SETTINGS_INHERIT_FROM_PARENT;
      endif; ?>
    </td>
  </tr>
  <tr>
    <td colspan='2'>
      <input type='hidden' name='DaysToHold' size='4' value="<?=htmlspecialchars($Array->DaysToHold)?>">
    </td>
  </tr>
 	<?=($type == 2 && !$BaseClassID && !($Array->ClassTemplate || $phase==15) ? "
    <tr><td colspan='2'><font color='gray'>
      <a href='ExportToFile.php?ClassID=".$ClassID."&amp;".$nc_core->token->get_url()."'>".CONTROL_CLASS_EXPORT."</a></font>
    </td></tr>" : "")?>
	</table>
	<br/>

	<div align='right'>
	<?php
	if($type==1 || $BaseClassID) {
    $UI_CONFIG->actionButtons[] = array(
      "id" => "submit",
      "caption" => $phase==15 ? CONTROL_CLASS_CLASS_TEMPLATE_ADD : CONTROL_CLASS_ADD,
      "action" => "mainView.submitIframeForm()"
    );
	}
	elseif ($type > 1) {
    $UI_CONFIG->actionButtons[] = array(
      "id" => "submit",
      "caption" => CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_SAVE,
      "action" => "mainView.submitIframeForm()"
    );
    // add component template button
    if ( !($Array->ClassTemplate || $phase==15)  ) {
      $UI_CONFIG->actionButtons[] = array(
        "id" => "submit",
        "align" => "left",
        "caption" => CONTROL_CLASS_CLASS_TEMPLATE_ADD,
        "location" => "classtemplate.add(".($type == 3 ? $Array->Class_ID : $ClassID).")"
      );
    }
    global $system_env;
    if ($system_env['SyntaxCheck']) {
      $UI_CONFIG->actionButtons[] = array(
        "id" => "debug",
        "caption" => NETCAT_DEBUG_BUTTON_CAPTION,
        "action" => "document.getElementById('mainViewIframe').contentWindow.FormAsyncDebug()"
      );
    }
    $UI_CONFIG->actionButtons[] = array(
      "id" => "preview",
      "caption" => NETCAT_PREVIEW_BUTTON_CAPTIONCLASS,
      "action" => "document.getElementById('mainViewIframe').contentWindow.SendClassPreview('','../../index.php')"
    );
	}
	?>
	</div>

	<?php
	// Используется для мастера создания шаблонов
	global $Class_Type;
	echo "<input type='hidden' name='Class_Type' value='".$Class_Type."'>\n";
	if($BaseClassID) {
    print "<input type='hidden' name='BaseClassID' value='".$BaseClassID."'>\n";
  }
	else {
		print "<input type='hidden' name='ClassID' value='".$ClassID."'>\n";
  }

  print $nc_core->token->get_input();
  if ( $Array->System_Table_ID ) print "<input type='hidden' name='System_Table_ID' value='".$Array->System_Table_ID."'>\n";
  ?>


	<input type='hidden' name='ClassGroup' value='<?=$ClassGroup?>'>
	<input type='hidden' name='phase' value='<?=$phase?>'>
	<input type='hidden' name='type' value='<?=($BaseClassID ? 1 : $type)?>'>
  <?php if ($phase==15) echo "<input type='hidden' name='ClassTemplate' value='".$BaseClassID."'>"; ?>
	<?php if ($Array->ClassTemplate) echo "<input type='hidden' name='ClassTemplate' value='".$Array->ClassTemplate."'>"; ?>
  <input type='submit' class='hidden'>
	</form>

  <!--  START   REMIND_SAVE -->
  <script type='text/javascript'>remind_redaction();</script>
  <!-- END REMIND_SAVE -->

  <!-- Binding event_handlers to textarea resize link -->
  <script type='text/javascript'>
    (function (){
      var links = document.getElementsByTagName("A");
      var onclicker_grow   = function (event) { ShrinkArea(event, 50);  }
      var onclicker_shrink = function (event) { ShrinkArea(event,-50);  }
      for (var i = 0 ; i < links.length ; i++){
          if (links[i].className.search('textarea_shrink') != -1 ) {
            bindEvent(links[i], 'click', onclicker_grow );
          }
          if (links[i].className.search('textarea_grow') != -1 ) {
            bindEvent(links[i], 'click', onclicker_shrink);
          }
      }
    }) ();
  </script>
	<?
}


##############################################
# Добавление/изменение шаблона
##############################################
function ActionClassComleted ($type) {
	global $nc_core, $db, $ROOT_FOLDER;
	global $perm;

	foreach ($_POST as $key => $val) {
    eval("global \$".$key.";");
  }

	$AllowTags += 0;
	$NL2BR += 0;
	$RecordsPerPage += 0;
	$UseCaptcha = (int)$UseCaptcha;
  $CacheForUser += 0;

	if ($type == 1) {
    $insert = "INSERT INTO `Class` (`Class_Name`, `Class_Group`,  `AllowTags`, `NL2BR`, `FormPrefix`, `FormSuffix`, `RecordTemplate`, `RecordTemplateFull`, `RecordsPerPage`, `SortBy`, `TitleTemplate`, `Settings`, `UseCaptcha`, ".( $nc_core->modules->get_by_keyword("cache") ? "`CacheForUser`, " : "")."`CustomSettingsTemplate`, `ClassDescription`, `ClassTemplate`, `System_Table_ID`) ";
    $insert.= "VALUES ('".$ClassName."',";
    if ($Class_Group_New) {
      $insert.= "'".$Class_Group_New."',";
    }
    elseif ($Class_Group) {
      $insert.= "'".$Class_Group."',";
    }

    $insert.= "'".$AllowTags."',";
    $insert.= "'".$NL2BR."',";
    $insert.= "'".$FormPrefix."',";
    $insert.= "'".$FormSuffix."',";
    $insert.= "'".$RecordTemplate."',";
    $insert.= "'".$RecordTemplateFull."',";
    $insert.= "'".$RecordsPerPage."',";
    $insert.= "'".$SortBy."',";
    $insert.= "'".$TitleTemplate."',";
    $insert.= "'".$Settings."',";
    $insert.= "'".$UseCaptcha."',";
    if ( $nc_core->modules->get_by_keyword("cache") ) {
      $insert.= "'".$CacheForUser."',";
    }
    $insert.= "'".$CustomSettingsTemplate."',";
    $insert.= "'".$ClassDescription."',";
    $insert.= "'".$ClassTemplate."',";
    $insert.= "'".intval($System_Table_ID)."' )";

    $db->query($insert);
    $classInsertedID = $db->insert_id;

    if (!$ClassTemplate) {
      $nc_core->event->execute("addClass", $classInsertedID);
      // execute core action
      CreateMessageTable($classInsertedID, $db);
    }
    else {
      // main class, template class
      $nc_core->event->execute("addClassTemplate", $ClassTemplate, $classInsertedID);
    }

		return $classInsertedID;
 	}


	if ($type==2 || $type==3) {

    $update = "UPDATE `Class` SET ";
    if ($type==2) {
      $update.= "`Class_Name` = '".$ClassName."',";
      if ($Class_Group_New) {
        $update.= "`Class_Group` = '".$Class_Group_New."',";
      }
      else {
        $update.= "`Class_Group` = '".$Class_Group."',";
      }
    }
 
    $update.= "`AllowTags` = '".$AllowTags."',";
    $update.= "`NL2BR` = '".$NL2BR."',";
    $update.= "`FormPrefix` = '".$FormPrefix."',";
    $update.= "`FormSuffix` = '".$FormSuffix."',";
    $update.= "`RecordTemplate` = '".$RecordTemplate."',";
    $update.= "`RecordTemplateFull` = '".$RecordTemplateFull."',";
    $update.= "`RecordsPerPage` = '".$RecordsPerPage."',";
    $update.= "`SortBy` = '".$SortBy."',";
    $update.= "`TitleTemplate` = '".$TitleTemplate."',";
    $update.= "`Settings` = '".$Settings."',";
    $update.= "`UseCaptcha` = '".$UseCaptcha."',";
    if ( $nc_core->modules->get_by_keyword("cache") ) {
      $update.= "`CacheForUser` = '".$CacheForUser."',";
    }
    $update.= "`CustomSettingsTemplate` = '".$CustomSettingsTemplate."', ";
    $update.= "`ClassDescription` = '".$ClassDescription."'";
    // where string for Class or SystemTable
    if ($type==2) $update .= " WHERE `Class_ID` = '".intval($ClassID)."'";
    if ($type==3) $update .= " WHERE `System_Table_ID` = '".intval($ClassID)."' AND `ClassTemplate` = 0";

    $db->query($update);

    // execute core action
    if ($type==2) {
      if (!$ClassTemplate) {
        $nc_core->event->execute("updateClass", $ClassID);
      }
      else {
        // main class, template class
        $nc_core->event->execute("updateClassTemplate", $ClassTemplate, $ClassID);
      }
    }
    if ($type==3) $nc_core->event->execute("updateSystemTable", 3);

    return $db->rows_affected;
	}
}


/*
 * Вывод списка шаблонов при создании нового
 */
function addNewTemplate($Class_Group = "") {
  global $db, $UI_CONFIG, $ADMIN_PATH;

	$classes = $db->get_results("SELECT `Class_ID` AS value,
		CONCAT(`Class_ID`, '. ', `Class_Name`) AS description,
		`Class_Group` AS optgroup
		FROM `Class`
		ORDER BY `Class_Group`, `Class_ID`", ARRAY_A);

	?>
	<fieldset>
	<legend>
	<b><font color='gray'><?=CONTROL_CLASS_CLASS_CREATENEW_BASICOLD?></font></b>
	</legend>
	<form method='get' style='padding:15px 20px 10px'>
	<table border='0' cellpadding='0' cellspacing='0'>
	<tr>
	<td width='80%'>
	<?
	echo "<select name='BaseClassID'>";
	echo "<option value='0'>".CONTROL_CLASS_CLASS_CREATENEW_CLEARNEW."</option>";
	if ( !empty($classes) ) echo nc_select_options($classes);
	echo "</select>";
	?>
	</td>
	<td>&nbsp;</td>
	</tr>
	</table>
	<?
	$UI_CONFIG->actionButtons[] = array(
    "id" => "submit",
		"caption" => CONTROL_CLASS_CONTINUE,
		"action" => "mainView.submitIframeForm()"
  );
	if ($Class_Group) {
		print "<input type='hidden' name='ClassGroup' value='".$Class_Group."'>";
	}
	?>
	<input type='hidden' name='phase' value='2'>
	<input type='submit' class='hidden'>
	</form>
	</fieldset>
	<?
}


##############################################
# Подтверждение удаления
##############################################
function ConfirmDeletion ($Class_Group = '')
{
	global $db;
	global $UI_CONFIG;
	$ask = false;

  $class_id = 0;
  $class_id_array = array();
	print "<form method='post' action='index.php'>";

  $nc_core = nc_Core::get_object();
  $template_class_id_array = array();

  $input = $nc_core->input->fetch_get_post();

  if ( !empty($input) ) {
  	foreach($input as $key => $val) {
  		if ( nc_substr($key, 0, 6)=="Delete" && $val ) {
  			$ask = true;

  			$class_id = intval($val);
  			$class_id_array[] = $class_id;

  			$SelectArray = $db->get_var("SELECT `Class_Name` FROM `Class` WHERE `Class_ID`='".$class_id."'") ;

  			print "<input type='hidden' name='".$key."' value='".$val."'>";
  			$class_counter++;

        $template_ids = $db->get_col("SELECT Class_ID FROM Class WHERE ClassTemplate = '".$class_id."'");
        if ( $template_ids ) $template_class_id_array = array_merge ($template_class_id_array, $template_ids);
  		}
  	}
  }

	if (!$ask) return false;

	if ($class_counter > 1) {
		$UI_CONFIG = new ui_config_class("delete", "", $ClassGroup);
		$post_f1 = CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_WARNING_SITEDELETE_I;
		$post_f2 = CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_WARNING_SITEDELETE_U;
	} else {
		print "<input type='hidden' name='ClassGroup' value='".$db->get_var("SELECT md5(`Class_Group`) FROM `Class` WHERE `Class_ID` = '".$class_id."' GROUP BY `Class_Group`")."'>";
		$UI_CONFIG = new ui_config_class('delete', $class_id, $ClassGroup);
	}
	nc_print_status(CONTROL_CLASS_CLASS_DELETE_WARNING, 'info', array($post_f1, $post_f2));
	
  print $nc_core->token->get_input();
  print "
	<input type='hidden' name='phase' value='7'>
	</form>
	";
	nc_list_class_use($class_id_array, 0, 0);
  if ( $template_class_id_array ) {
    echo "<br/>";
    nc_list_class_template_use($template_class_id_array);
  }
	$UI_CONFIG->actionButtons[] = array(
    "id" => "submit",
    "caption" => CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_CONFIRMDELETE,
    "action" => "mainView.submitIframeForm()"
  );

	return true;
}


function ConfirmClassTemplateDeletion ($ClassTemplate = 0) {
	global $UI_CONFIG;

  // system superior object
  $nc_core = nc_Core::get_object();

  // system db object
  if ( is_object($nc_core->db) ) $db = &$nc_core->db;

  $ask = false;
	$class_id = 0;
  $class_id_array = array();
  $ClassTemplate = intval($ClassTemplate);

	print "<form method='post' action='index.php'>";

  $need_arr = $nc_core->input->fetch_get_post();

  if ( !empty($need_arr) ) {
  	foreach($need_arr as $key => $val) {
  		if ( substr($key, 0, 6)=="Delete" && $val ) {
  			$ask = true;

  			$class_id = intval($val);
  			$class_id_array[] = $class_id;

  			print "<input type='hidden' name='".$key."' value='".$val."'>";
  			$class_counter++;
  		}
  	}
  }

	if (!$ask) return false;

  if ($ClassTemplate) {
    $BaseClassName = $db->get_var("SELECT `Class_Name` FROM `Class` WHERE `Class_ID` = '".$ClassTemplate."'");
  }
  else {
    list($ClassTemplate, $BaseClassName) = $nc_core->db->get_row("SELECT mc.`Class_ID`, mc.`Class_Name` FROM `Class` AS tc
    LEFT JOIN `Class` AS mc ON tc.`ClassTemplate` = mc.`Class_ID`
    WHERE tc.`Class_ID` = '".$class_id."'", ARRAY_N);
  }

	if ($class_counter > 1) {
		$UI_CONFIG = new ui_config_class_template("delete", 0, $ClassTemplate);
		//$post_f1 = CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_WARNING_SITEDELETE_I;
		//$post_f2 = CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_WARNING_SITEDELETE_U;
	}
  else {
		$UI_CONFIG = new ui_config_class_template('delete', $class_id);
	}
	// notice
  nc_print_status( sprintf(CONTROL_CLASS_CLASS_TEMPLATE_DELETE_WARNING, $BaseClassName), 'info'); //, array($post_f1, $post_f2)
	print $nc_core->token->get_input();
  ?>
	<input type='hidden' name='phase' value='19'>
  <input type='hidden' name='ClassTemplate' value='<?=$ClassTemplate?>'>
	</form>
	<?php
	nc_list_class_template_use($class_id_array, 0);
	$UI_CONFIG->actionButtons[] = array(
    "id" => "submit",
    "caption" => CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_CONFIRMDELETE,
    "action" => "mainView.submitIframeForm()"
  );

}

/*
 * Удаление шаблона
 */
function CascadeDeleteClass ($ClassID) {
	global $nc_core, $db;
	global $UI_CONFIG, $INCLUDE_FOLDER;

  $ClassID = intval($ClassID);

  // удаление шаблонов
  $template_ids = $db->get_col("SELECT Class_ID FROM Class WHERE ClassTemplate = '".$ClassID."'");
  if ( !empty($template_ids) ) foreach ( $template_ids as $v ) {
    CascadeDeleteClassTemplate($v);
  }

  

	$ClassGroup = $db->get_var("SELECT `Class_Group` FROM `Class` WHERE `Class_ID` = '".$ClassID."'");
	$isMoreClasses = $db->get_var("SELECT COUNT(*) - 1 FROM `Class` WHERE `Class_Group` = '".$ClassGroup."'");

	//$LockTables = "LOCK TABLES `Class` WRITE, `Field` WRITE,";
	//$LockTables.= "`Message".$ClassID."` WRITE,";
	//$LockTables.= "`Sub_Class` WRITE";

	//$LockResult = $db->query($LockTables.$AddLockTables);

  // get ids
  $messages = $db->get_results("SELECT sc.`Catalogue_ID`, m.`Subdivision_ID`, m.`Sub_Class_ID`, m.`Message_ID`
    FROM `Message".$ClassID."` AS m
    LEFT JOIN `Sub_Class` AS sc ON sc.`Sub_Class_ID` = m.`Sub_Class_ID`
    ORDER BY sc.`Catalogue_ID`, m.`Subdivision_ID`, m.`Sub_Class_ID`", ARRAY_N);
  // delete messages
  $db->query("DROP TABLE `Message".$ClassID."`");
  // call event
  if ( !empty($messages) ) {
    $catalogue = $messages[0][0];
    $sub = $messages[0][1];
    $cc = $messages[0][2];
    $messages_arr = array($messages[0][3]);
    foreach ($messages as $value) {
      if ($value[0]!=$catalogue || $value[1]!=$sub || $value[2]!=$cc) {
        // execute core action
        $nc_core->event->execute("dropMessage", $catalogue, $sub, $cc, $ClassID, $messages_arr);
        $catalogue = $value[0];
        $sub = $value[1];
        $cc = $value[2];
        $messages_arr = array($value[3]);
      }
      else {
        $messages_arr[] = $value[3];
      }
    }
  }

  // delete fields
  $db->query("DELETE FROM `Field` WHERE `Class_ID` = '".$ClassID."'");

  $subclasses = $db->get_results("SELECT `Catalogue_ID`, `Subdivision_ID`, `Sub_Class_ID`, `Class_ID` FROM `Sub_Class`
    WHERE `Class_ID` = '".$ClassID."'", ARRAY_N);
  // delete subclasses
  if ( !empty($subclasses) ) {
    foreach ($subclasses as $subclass) {
      // delete related files
      require_once ($INCLUDE_FOLDER."s_files.inc.php");
      DeleteSubClassFiles ($subclass[2], $subclass[3]);
      $db->query("DELETE FROM `Sub_Class` WHERE `Sub_Class_ID` = '".$subclass[2]."'");
      // execute core action
      $nc_core->event->execute("dropSubClass", $subclass[0], $subclass[1], $subclass[2]);
    }
  }

	$db->query("DELETE FROM `Class` WHERE `Class_ID` = '".$ClassID."'");
  // execute core action
  $nc_core->event->execute("dropClass", $ClassID);

	//$UnlockResult = $db->query("UNLOCK TABLES");

	if (!$isMoreClasses) {
		$UI_CONFIG->treeChanges['deleteNode'][] = "group-".md5($ClassGroup);
	}
  else {
		$UI_CONFIG->treeChanges['deleteNode'][] = "dataclass-".$ClassID;
	}

	return $isMoreClasses;
}


function CascadeDeleteClassTemplate ($ClassTemplateID) {
	global $UI_CONFIG;

  // system superior object
  $nc_core = nc_Core::get_object();

  // system db object
  if ( is_object($nc_core->db) ) $db = &$nc_core->db;

  $ClassTemplateID = intval($ClassTemplateID);

  list($mainComponentID, $type) = $nc_core->db->get_row("SELECT `ClassTemplate`, `Type` FROM `Class`
    WHERE `Class_ID` = '".$ClassTemplateID."'", ARRAY_N);
  $isMoreClassTemplates = 0;
  if ($mainComponentID) {
    $isMoreClassTemplates = $db->get_var("SELECT COUNT(*) - 1 FROM `Class` WHERE `ClassTemplate` = '".$mainComponentID."'");
  }

  if ( $type == 'rss' ) $added_sql = " `AllowRSS` = 0 ";
  if ( $type == 'xml' ) $added_sql = " `AllowXML` = 0 ";

  if (  $added_sql ) {
    $subclasses = $nc_core->db->get_results("SELECT `Catalogue_ID`, `Subdivision_ID`, `Sub_Class_ID` FROM `Sub_Class`
    WHERE `Class_ID` = '".$mainComponentID."' ", ARRAY_N);
    if ( !empty($subclasses) )  foreach ($subclasses as $subclass) {
      $nc_core->db->query("UPDATE `Sub_Class` SET ".$added_sql."
        WHERE `Sub_Class_ID` = '".$subclass[2]."'");
      // execute core action
      $nc_core->event->execute("updateSubClass", $subclass[0], $subclass[1], $subclass[2]);
    }
  
  }

  $subclasses = $nc_core->db->get_results("SELECT `Catalogue_ID`, `Subdivision_ID`, `Sub_Class_ID` FROM `Sub_Class`
    WHERE `Class_Template_ID` = '".$ClassTemplateID."'", ARRAY_N);
  // update subclasses
  if ( !empty($subclasses) ) {
    foreach ($subclasses as $subclass) {
      $nc_core->db->query("UPDATE `Sub_Class` SET `Class_Template_ID` = '0'
        WHERE `Sub_Class_ID` = '".$subclass[2]."'");
      // execute core action
      $nc_core->event->execute("updateSubClass", $subclass[0], $subclass[1], $subclass[2]);
    }
  }

	$nc_core->db->query("DELETE FROM `Class` WHERE `Class_ID` = '".$ClassTemplateID."'");
  // execute core action
  $nc_core->event->execute("dropClassTemplate", $mainComponentID, $ClassTemplateID);

	if (!$isMoreClassTemplates && $mainComponentID) {
		$UI_CONFIG->treeChanges['deleteNode'][] = "classtemplates-".$mainComponentID;
	}
  else {
		$UI_CONFIG->treeChanges['deleteNode'][] = "classtemplate-".$ClassTemplateID;
	}

	return $nc_core->db->rows_affected;
}


/**
 * Форма действий шаблона
 *
 * @param int $ClassID or SystemTableID
 * @param string action -
 * @param int $phase
 * @param int type: 1 - class, 2 - system table
 * @param int myaction: 1 - add, 2 - edit, 3 - search, 4 - subscribe, 5 - delete
 */
function ClassActionForm ($ClassID, $action, $phase, $type, $myaction) {
	global $ClassGroup, $SystemTableID, $user_table_mode, $nc_personal;
	global $UI_CONFIG;

  // system superior object
  $nc_core = nc_Core::get_object();

  // system db object
  if ( is_object($nc_core->db) ) $db = &$nc_core->db;

	if (!$ClassID) {
		print nc_print_status(CONTROL_CLASS_ERRORS_DB, 'error');
		return;
	}

	?>
	<form method='post' action='<?=$action?>'>
	<font color='gray'>
	<?php
	// Personal
  if ( !$nc_personal ) {
    $select = "SELECT `AddTemplate`, `AddCond`, `AddActionTemplate`,
    `EditTemplate`, `EditCond`, `EditActionTemplate`, `CheckActionTemplate`,
	  `DeleteTemplate`, `DeleteCond`, `DeleteActionTemplate`,
    `SearchTemplate`, `FullSearchTemplate`, `SubscribeTemplate`, `SubscribeCond`";
  }
  else {
    $select = "SELECT 'Недоступно в редакции Personal' AS AddTemplate, `AddCond`, `AddActionTemplate`,
      'Недоступно в редакции Personal' AS EditTemplate, `EditCond`, `EditActionTemplate`, `CheckActionTemplate`,
      `DeleteTemplate`, `DeleteCond`, `DeleteActionTemplate`,
      `SearchTemplate`, `FullSearchTemplate`, `SubscribeTemplate`, `SubscribeCond`";
  }

  // class or system table
	$select.= ($type == 1) ? " FROM `Class` WHERE `Class_ID` = " : " FROM `Class` WHERE `ClassTemplate` = 0 AND `System_Table_ID` = ";
  $select.= "'".intval($ClassID)."'";

	if ( !$Array = $nc_core->db->get_row($select) ) {
		print nc_print_status(CONTROL_CLASS_ERRORS_DB, "error");
	  exit();
	}

 	$show_generate_link = false;
	if (!$SystemTableID || $SystemTableID==3) {
		$show_generate_link = true;
		$sysTable = $SystemTableID ? $SystemTableID : 0;
	}

  // is template?
  $classTemplate = ($type==1 ? $nc_core->component->get_by_id($ClassID, "ClassTemplate") : 0);

	// Add, edit, delete, search or subscribe
	switch ($myaction) {
    // add
    case 1:
      if ($type == 1) {
        if (!$classTemplate) {
          $UI_CONFIG = new ui_config_class('customadd', $ClassID);
        }
        else {
          $UI_CONFIG = new ui_config_class_template('customadd', $ClassID);
        }
      }
      if ($type == 2) $UI_CONFIG = new ui_config_system_class('customadd', $SystemTableID);
      print_resizeblock("AddTemplate");
      print CONTROL_CLASS_CLASS_FORMS_ADDFORM.($show_generate_link  && !$nc_personal ? " (<a href='#' onclick=\"generateForm(".($classTemplate ? $classTemplate : $ClassID).", ".$sysTable.", 'AddTemplate'); return false;\">".CONTROL_CLASS_CLASS_FORMS_ADDFORM_GEN."</a>)" : "").":<br><TEXTAREA ROWS='10' WRAP='OFF' COLS='60' NAME='AddTemplate' id='AddTemplate' ".($nc_personal ? 'disabled' : '').">".htmlspecialchars($Array->AddTemplate)."</TEXTAREA><br><br>";
      print_resizeblock("AddCond");
      print CONTROL_CLASS_CLASS_FORMS_ADDRULES.($show_generate_link ? " (<a href='#' onclick=\"generateForm(".($classTemplate ? $classTemplate : $ClassID).", ".$sysTable.", 'AddCond'); return false;\">".CONTROL_CLASS_CLASS_FORMS_ADDCOND_GEN."</a>)" : "").":<br><TEXTAREA ROWS='10' WRAP='OFF' COLS='60' NAME='AddCond' id='AddCond'>".htmlspecialchars($Array->AddCond)."</TEXTAREA><br><br>";
      print_resizeblock("AddActionTemplate");
      print CONTROL_CLASS_CLASS_FORMS_ADDLASTACTION.($show_generate_link ? " (<a href='#' onclick=\"generateForm(".($classTemplate ? $classTemplate : $ClassID).", ".$sysTable.", 'AddActionTemplate'); return false;\">".CONTROL_CLASS_CLASS_FORMS_ADDACTION_GEN."</a>)" : "").":<br><TEXTAREA ROWS='10' WRAP='OFF' COLS='60' NAME='AddActionTemplate' id='AddActionTemplate'>".htmlspecialchars($Array->AddActionTemplate)."</TEXTAREA><br><br>";
      print "<script type='text/javascript'> remind_add(); </script>";
      print_bind();
    break;
    // edit
    case 2:
      if ($type == 1) {
        if (!$classTemplate) {
          $UI_CONFIG = new ui_config_class('customedit', $ClassID);
        }
        else {
          $UI_CONFIG = new ui_config_class_template('customedit', $ClassID);
        }
      }
      if ($type == 2) $UI_CONFIG = new ui_config_system_class('customedit', $SystemTableID);
      print_resizeblock("EditTemplate");
      print CONTROL_CLASS_CLASS_FORMS_EDITFORM."".($show_generate_link  && !$nc_personal ? " (<a href='#' onclick=\"generateForm(".($classTemplate ? $classTemplate : $ClassID).", ".$sysTable.", 'EditTemplate'); return false;\">".CONTROL_CLASS_CLASS_FORMS_EDITFORM_GEN."</a>)" : "").":<br><TEXTAREA ROWS='10' WRAP='OFF' COLS='60' NAME='EditTemplate' id='EditTemplate' ".($nc_personal ? 'disabled' : '').">".htmlspecialchars($Array->EditTemplate)."</TEXTAREA><br><br>";
      print_resizeblock("EditCond");
      print CONTROL_CLASS_CLASS_FORMS_EDITRULES.($show_generate_link ? " (<a href='#' onclick=\"generateForm(".($classTemplate ? $classTemplate : $ClassID).", ".$sysTable.", 'EditCond'); return false;\">".CONTROL_CLASS_CLASS_FORMS_EDITCOND_GEN."</a>)" : "").":<br><TEXTAREA ROWS='10' WRAP='OFF' COLS='60' NAME='EditCond' id='EditCond'>".htmlspecialchars($Array->EditCond)."</TEXTAREA><br><br>";
      print_resizeblock("EditActionTemplate");
      print CONTROL_CLASS_CLASS_FORMS_EDITLASTACTION.($show_generate_link ? " (<a href='#' onclick=\"generateForm(".($classTemplate ? $classTemplate : $ClassID).", ".$sysTable.", 'EditActionTemplate'); return false;\">".CONTROL_CLASS_CLASS_FORMS_EDITACTION_GEN."</a>)" : "").":<br><TEXTAREA ROWS='10' WRAP='OFF' COLS='60' NAME='EditActionTemplate' id='EditActionTemplate'>".htmlspecialchars($Array->EditActionTemplate)."</TEXTAREA><br><br>";
      print_resizeblock("CheckActionTemplate");
      print CONTROL_CLASS_CLASS_FORMS_ONONACTION.($show_generate_link ? " (<a href='#' onclick=\"generateForm(".($classTemplate ? $classTemplate : $ClassID).", ".$sysTable.", 'CheckActionTemplate'); return false;\">".CONTROL_CLASS_CLASS_FORMS_CHECKACTION_GEN."</a>)" : "").":<br><TEXTAREA ROWS='10' WRAP='OFF' COLS='60' NAME='CheckActionTemplate' id='CheckActionTemplate'>".htmlspecialchars($Array->CheckActionTemplate)."</TEXTAREA><br><br>";
      print_bind();
    break;
    // search
    case 3:
      if ($type == 1) {
        if (!$classTemplate) {
          $UI_CONFIG = new ui_config_class('customsearch', $ClassID);
        }
        else {
          $UI_CONFIG = new ui_config_class_template('customsearch', $ClassID);
        }
      }
      if ($type == 2) $UI_CONFIG = new ui_config_system_class('customsearch', $SystemTableID);
      print_resizeblock("FullSearchTemplate");
			print CONTROL_CLASS_CLASS_FORMS_QSEARCH."".($show_generate_link ? " (<a href='#' onclick=\"generateForm(".($classTemplate ? $classTemplate : $ClassID).", ".$sysTable.", 'FullSearchTemplate'); return false;\">".CONTROL_CLASS_CLASS_FORMS_QSEARCH_GEN."</a>)" : "").":<br><TEXTAREA ROWS='10' WRAP='OFF' COLS='60' NAME='FullSearchTemplate' id='FullSearchTemplate'>".htmlspecialchars($Array->FullSearchTemplate)."</TEXTAREA><br><br>";
      print_resizeblock("SearchTemplate");
      print CONTROL_CLASS_CLASS_FORMS_SEARCH."".($show_generate_link ? " (<a href='#' onclick=\"generateForm(".($classTemplate ? $classTemplate : $ClassID).", ".$sysTable.", 'SearchTemplate'); return false;\">".CONTROL_CLASS_CLASS_FORMS_SEARCH_GEN."</a>)" : "").":<br><TEXTAREA ROWS='10' WRAP='OFF' COLS=60 NAME='SearchTemplate' id='SearchTemplate'>".htmlspecialchars($Array->SearchTemplate)."</TEXTAREA><br><br>";
      print "<script type='text/javascript'> remind_search(); </script>";
      print_bind();
    break;
    // subscribe
    case 4:
      if ($type == 1) {
        if (!$classTemplate) {
          $UI_CONFIG = new ui_config_class('customsubscribe', $ClassID);
        }
        else {
          $UI_CONFIG = new ui_config_class_template('customsubscribe', $ClassID);
        }
      }
      if ($type == 2) $UI_CONFIG = new ui_config_system_class('customsubscribe', $SystemTableID);
      print_resizeblock("SubscribeCond");
      print CONTROL_CLASS_CLASS_FORMS_MAILRULES.":<br><TEXTAREA ROWS='10' WRAP='OFF' COLS='60' NAME='SubscribeCond' id='SubscribeCond'>".htmlspecialchars($Array->SubscribeCond)."</TEXTAREA><br><br>";
      print_resizeblock("SubscribeTemplate");
      print CONTROL_CLASS_CLASS_FORMS_MAILTEXT.":<br><TEXTAREA ROWS='10' WRAP='OFF' COLS='60' NAME='SubscribeTemplate' id = 'SubscribeTemplate'>".htmlspecialchars($Array->SubscribeTemplate)."</TEXTAREA><br><br>";
      print "<script type='text/javascript'> remind_subscrib(); </script>";
      print_bind();
    break;
    // delete
    case 5:
      if ($type == 1) {
        if (!$classTemplate) {
          $UI_CONFIG = new ui_config_class('customdelete', $ClassID);
        }
        else {
          $UI_CONFIG = new ui_config_class_template('customdelete', $ClassID);
        }
      }
      if ($type == 2) $UI_CONFIG = new ui_config_system_class('customdelete', $SystemTableID);
      print_resizeblock("DeleteTemplate");
      print CONTROL_CLASS_CLASS_FORMS_DELETEFORM.($show_generate_link ? " (<a href='#' onclick=\"generateForm(".($classTemplate ? $classTemplate : $ClassID).", ".$sysTable.", 'DeleteTemplate'); return false;\">".CONTROL_CLASS_CLASS_FORMS_EDITFORM_GEN."</a>)" : "")."<br><TEXTAREA ROWS='10' WRAP='OFF' COLS='60' NAME='DeleteTemplate' id='DeleteTemplate'>".htmlspecialchars($Array->DeleteTemplate)."</TEXTAREA><br><br>";
      print_resizeblock("DeleteCond");
      print CONTROL_CLASS_CLASS_FORMS_DELETERULES.":<br><TEXTAREA ROWS='10' WRAP='OFF' COLS='60' NAME='DeleteCond' id='DeleteCond'>".htmlspecialchars($Array->DeleteCond)."</TEXTAREA><br><br>";
      print_resizeblock("DeleteActionTemplate");
      print CONTROL_CLASS_CLASS_FORMS_ONDELACTION.($show_generate_link ? " (<a href='#' onclick=\"generateForm(".($classTemplate ? $classTemplate : $ClassID).", ".$sysTable.", 'DeleteActionTemplate'); return false;\">".CONTROL_CLASS_CLASS_FORMS_DELETEACTION_GEN."</a>)" : "").":<br><TEXTAREA ROWS='10' WRAP='OFF' COLS='60' NAME='DeleteActionTemplate' id='DeleteActionTemplate'>".htmlspecialchars($Array->DeleteActionTemplate)."</TEXTAREA><br><br>";
      print "<script type='text/javascript'>remind_delete(); </script>";
      print_bind();
    break;
	}

  $UI_CONFIG->actionButtons[] = array(
    "id" => "submit",
    "caption" => CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_SAVE,
    "action" => "mainView.submitIframeForm()"
  );

  global $system_env;
  if ($system_env['SyntaxCheck']) {
    $UI_CONFIG->actionButtons[] = array(
      "id" => "debug",
      "caption" => NETCAT_DEBUG_BUTTON_CAPTION,
      "action" => "document.getElementById('mainViewIframe').contentWindow.FormAsyncDebug()"
    );
  }
  switch ($myaction) {
    case 1:
      $UI_CONFIG->actionButtons[] = array(
        "id" => "preview",
        "caption" => NETCAT_PREVIEW_BUTTON_CAPTIONADDFORM,
        "action" => "document.getElementById('mainViewIframe').contentWindow.SendClassPreview('','../../add.php')"
      );
    break;
    case 2:
      $UI_CONFIG->actionButtons[] = array(
        "id" => "preview",
        "caption" => NETCAT_PREVIEW_BUTTON_CAPTIONEDITFORM,
        "action" => "document.getElementById('mainViewIframe').contentWindow.SendClassPreview('','../../message.php')"
      );
    break;
    case 3:
      $UI_CONFIG->actionButtons[] = array(
        "id" => "preview",
        "caption" => NETCAT_PREVIEW_BUTTON_CAPTIONSEARCHFORM,
        "action" => "document.getElementById('mainViewIframe').contentWindow.SendClassPreview('','../../search.php')"
      );
    break;
  }

  print $nc_core->token->get_input();
 	print "<input type='hidden' name='ClassID' value='".$ClassID."'/>\n";
 	print "<input type='hidden' name='phase' value='".$phase."'/>";
 	print "<input type='hidden' name='myaction' value='".$myaction."'/>";
 	print "<input type='hidden' name='type' value='".$type."'/>";
	print "<input type='hidden' name='ClassGroup' value='".$ClassGroup."'/>";
  print "<input type='hidden' name='ClassTemplate' value='".$classTemplate."'/>";
 	print "
	<input type='submit' class='hidden' />
  </font>
  </form>";
 	
}

##############################################
# Изменение форм действий шаблона
##############################################
function ClassActionCompleted ($myaction, $type) {
	global $nc_core, $db, $nc_personal;
	# type=1 - это шаблон
	# type=2 - это системная таблица
	# при type=2 ClassID - это на самом деле SystemTableID

	if ( !empty($_POST) ) {
    foreach ($_POST as $key => $val) {
  		eval("global \$".$key.";");
    }
  }

  $ClassID = intval($ClassID);

	$update = "UPDATE `Class` SET ";
	switch ($myaction) {

    case 1:
      if ( !$nc_personal ) $update.= "`AddTemplate` = '".$AddTemplate."',";
      $update.= "`AddCond` = '".$AddCond."',";
      $update.= "`AddActionTemplate` = '".$AddActionTemplate."'";
    break;

    case 2:
      if ( !$nc_personal )  $update.= "`EditTemplate` = '".$EditTemplate."',";
      $update.= "`EditCond` = '".$EditCond."',";
      $update.= "`EditActionTemplate` = '".$EditActionTemplate."',";
      $update.= "`CheckActionTemplate` = '".$CheckActionTemplate."'";

    break;

    case 3:
      $update.= "`FullSearchTemplate` = '".$FullSearchTemplate."',";
      $update.= "`SearchTemplate` = '".$SearchTemplate."'";
    break;

    case 4:
      $update.= "`SubscribeCond` = '".$SubscribeCond."',";
      $update.= "`SubscribeTemplate` = '".$SubscribeTemplate."'";
    break;

    case 5:
      $update.= "`DeleteTemplate` = '".$DeleteTemplate."',";
      $update.= "`DeleteCond` = '".$DeleteCond."',";
      $update.= "`DeleteActionTemplate` = '".$DeleteActionTemplate."'";
    break;
	}

	if ($type==1) $update.= " WHERE `Class_ID` = '".$ClassID."'";
	if ($type==2) $update.= " WHERE `System_Table_ID` = '".$ClassID."' AND `ClassTemplate` = 0";

 	$db->query($update);

  // execute core action
  if ($type==1) {
    if (!$ClassTemplate) {
      $nc_core->event->execute("updateClass", $ClassID);
    }
    else { 
      // main class, template class
      $nc_core->event->execute("updateClassTemplate", $ClassTemplate, $ClassID);
    }
  }
  if ($type==2) $nc_core->event->execute("updateSystemTable", 3);
}


function nc_class_info($class_id) {
  global $db, $UI_CONFIG;

  $class_id = intval($class_id);

  $info = $db->get_row("SELECT `ClassDescription`, `CustomSettingsTemplate` FROM `Class` WHERE `Class_ID` = '".$class_id."'", ARRAY_A);
  $fields = $db->get_results("SELECT `Field_Name`, `Description` FROM `Field` WHERE `Class_ID` = '".$class_id."' ORDER BY `Priority`", ARRAY_A);

  echo "<table border='0' cellpadding='0' cellspacing='0' width='100%'><tr><td bgcolor='#CCCCCC'>\n<table border='0' cellpadding='6' cellspacing='1' width='100%'>";
  if ($info['ClassDescription']) echo "<tr><td colspan='2' bgcolor='#FFFFFF'><b>".CONTROL_CLASS_CLASS_DESCRIPTION.":</b><br><br>".$info['ClassDescription']."</td></tr>";
  echo "<tr>";
  echo "<td width='50%' bgcolor='#FFFFFF'>";

  if ($fields) {
    echo "<b>".CONTROL_CLASS_FIELDS.":</b><br>";
    echo "<ol>";
    foreach ($fields as $field) {
      echo "<li>".$field['Description']." (".$field['Field_Name'].")<br>\n";
    }
    echo "</ol>";
  } else {
    echo CONTROL_FIELD_LIST_NONE;
  }

  echo "</td>";
  echo "<td width='50%' bgcolor='#FFFFFF'>";
  if ($info['CustomSettingsTemplate']) {
    eval($info['CustomSettingsTemplate']);
    echo "<b>".CONTROL_CLASS_CUSTOM_SETTINGS_TEMPLATE.":</b><br>";
    echo "<ol>";
    foreach($settings_array as $settings) {
      echo "<li>".$settings['caption']."<br>\n";
    }
    echo "</ol>";
  } else {
    echo CONTROL_CLASS_CUSTOM_SETTINGS_ISNOTSET;
  }
  echo "</td>";
  echo "</tr>";
  echo "</table>\n</td></tr></table>";
}


/**
 * Show using class
 *
 * @param array | null arrayClassID, if !isset - all class
 * @param int 0 - all, 1 - only used, 2 - only unused
 * @param show "checkbox" for clear subClass
 */
function nc_list_class_use ($arrayClassID, $param_show = 0, $withdeleted = 1) {
  global $db, $nc_core;

  $colspan = $withdeleted ? 5 : 4;

  if ( !empty($arrayClassID) ) $arrayClassID = array_map("intval", $arrayClassID);

  $Result = $db->get_results("SELECT Class.`Class_ID` AS ClassID, Class.`Class_Name` AS ClassName,
    Sub_Class.`Sub_Class_ID` AS SubClassID, Sub_Class.`Sub_Class_Name` AS SubClassName, Sub_Class.`EnglishName` AS SubClassKeyword,
    Subdivision.`Subdivision_Name` AS SubName, Subdivision.`Subdivision_ID` AS SubID, Subdivision.`Hidden_URL` AS SubURL
    FROM `Class`
    LEFT JOIN `Sub_Class` ON Sub_Class.`Class_ID` = Class.`Class_ID`
    LEFT JOIN `Subdivision` ON Subdivision.`Subdivision_ID` = Sub_Class.`Subdivision_ID`
    WHERE ".( !empty($arrayClassID) ? "Class.`Class_ID` IN(".join(",", $arrayClassID).")" : "Class.`System_Table_ID` = '0' AND Class.`ClassTemplate` = '0'" ), ARRAY_A);

  $curClass = -1;

  if ( $withdeleted ) echo "<form action='index.php' name='del' method='post' id='del'>\n";

  echo "<table border='0' cellpadding='0' cellspacing='0' width='100%'><tr><td bgcolor='#cccccc'>\n".
    "<table border='0' cellpadding='4' cellspacing='1' width='100%'>\n".
    "<tr>\n".
    "<td bgcolor='#EEEEEE' width='30%'><font size='-2'><b>".CONTROL_CLASS."</b></td>\n".
    "<td bgcolor='#EEEEEE' width='30%'><font size='-2'><b>".CONTROL_CONTENT_SUBDIVISION_FUNCS_SECTION."</b></td>\n".
    "<td bgcolor='#EEEEEE' width='30%'><font size='-2'><b>".CONTROL_CONTENT_SUBDIVISION_CLASS."</b></td>\n".
    "<td bgcolor='#EEEEEE' align='center'><font size='-2'><b>".CONTROL_CONTENT_SUBCLASS_TOTALOBJECTS."</b></td>\n".
    ($withdeleted ? "<td bgcolor='#EEEEEE' align='center'><font size='-2'><b>".REPORTS_STAT_CLASS_CLEAR."</b></td>\n" : "").
    "</tr>";

  $str = "";
  foreach ( $Result as $row  ) {

    if ( $curClass != $row['ClassID'] ) {
      switch ($param_show) {
        case 0:
          print($str);
        break;
        case 1:
          if( $useSubClass ) print($str);
        break;
        case 2:
          if( !$useSubClass ) print($str);
        break;
      }

      //так сделано, чтобы для первого класса не выводился раздилитель
      $str = $divider;

      $str .= "<tr>";
      $divider = "<tr><td colspan='".$colspan."' height='2px' bgcolor='#CCCCCC'  style='padding: 0px'></tr>";
      $curClass = $row['ClassID'];
      $db->query("SELECT COUNT(`Message_ID`), `Sub_Class_ID` FROM `Message".$curClass."` GROUP BY `Sub_Class_ID`");
      unset($countMes);
      if ( $db->get_col(null, 1) ) {
        $countMes = array_combine( (array)$db->get_col(null, 1),  (array)$db->get_col(null, 0) );
      }
      $db->query("SELECT COUNT(`Message_ID`), `Sub_Class_ID` FROM `Message".$curClass."` WHERE `Checked` = 0 GROUP BY `Sub_Class_ID`");

      unset($countMes_off);
      if ( $db->get_col(null, 1) ) {
        $countMes_off = array_combine( (array)$db->get_col(null, 1),  (array)$db->get_col(null, 0) );
      }
      $useSubClass = false;
      if( $row['SubClassID']) $useSubClass = true;
        $str.= "<td bgcolor='#FFFFFF'><a href='../class/index.php?phase=4&amp;ClassID=".$curClass."' style='text-decoration:none'>".
          "<b><font color='#000000'>".$curClass.". ".$row['ClassName']."</b></font></a></td>";
      }
      else {
        $str.= "<tr><td bgcolor='#FFFFFF'><font size='-2'></td>";
      }

      if ( $row['SubID']) {
        $temp1 = "<a href = '".$row['SubURL']."' style='text-decoration:underline' target='_blank'>".$row['SubID'].". ".$row['SubName']."</a>";
        $temp2 = "<a href = '".$row['SubURL'].$row['SubClassKeyword'].".html' style='text-decoration:underline' target='_blank'>".$row['SubClassID'].". ".$row['SubClassName']."</a>";
      }
      else {
        $temp1 = $temp2 =  "-";
      }

      $str .= "<td bgcolor='#FFFFFF'><font size='-2'>".$temp1."</td>".
        "<td bgcolor='#FFFFFF'><font size='-2'>".$temp2."</td>";

      $str.="<td align='center' bgcolor='#FFFFFF'>".$countMes[$row['SubClassID']];
      if ($countMes_off[$row['SubClassID']]) $str .= "(".$countMes_off[$row['SubClassID']].")";
      $str.= "</td>";
      if ($withdeleted ) {
        $str.= "<td align='center' bgcolor='#FFFFFF'>".($countMes[$row['SubClassID']] ? ("<input type='checkbox' value='".$row['SubClassID']."' name='Delete".$row['SubClassID']."'>") : "")."</td>";
      }
      $str.= "</tr>\r\n";
    }

    switch ($param_show) {
      case 0:
        print($str);
      break;
      case 1:
        if( $useSubClass ) print($str);
      break;
      case 2:
        if( !$useSubClass ) print($str);
      break;
    }

    print "</table></td></tr></table>";

    if ($withdeleted) {
      print "<input type='hidden' name='phase' value='3'></form>\n";
      print $nc_core->token->get_input();
    }
}


/**
 * Show using class
 *
 * @param array | null arrayClassID, if !isset - all class
 * @param int 0 - all, 1 - only used, 2 - only unused
 */
function nc_list_class_template_use ($arrayClassID, $param_show = 0) {
  // system superior object
  $nc_core = nc_Core::get_object();

  // system db object
  if ( is_object($nc_core->db) ) $db = &$nc_core->db;

  if ( empty($arrayClassID) ) {
    nc_print_status(CONTROL_CLASS_CLASS_TEMPLATE_ERROR_NOT_FOUND, "error");
    return false;
  }
  else {
    $arrayClassID = array_map("intval", $arrayClassID);
  }

  $Result = $nc_core->db->get_results("SELECT Class.`Class_ID` AS ClassID, Class.`Class_Name` AS ClassName,
    Sub_Class.`Sub_Class_ID` AS SubClassID, Sub_Class.`Sub_Class_Name` AS SubClassName,
    Subdivision.`Subdivision_Name` AS SubName, Subdivision.`Subdivision_ID` AS SubID
    FROM `Class`
    LEFT JOIN `Sub_Class` ON Sub_Class.`Class_ID` = Class.`ClassTemplate`
      AND Sub_Class.`Class_Template_ID` = Class.`Class_ID`
    LEFT JOIN `Subdivision` ON Subdivision.`Subdivision_ID` = Sub_Class.`Subdivision_ID`
    WHERE ".( !empty($arrayClassID) ? "Class.`Class_ID` IN(".join(",", $arrayClassID).")" : "Class.`System_Table_ID` = '0'" )."
      AND Class.`ClassTemplate` != '0'", ARRAY_A);

  $curClass = -1;

  echo "<table border='0' cellpadding='0' cellspacing='0' width='100%'><tr><td bgcolor='#cccccc'>\n".
    "<table border='0' cellpadding='4' cellspacing='1' width='100%'>\n".
    "<tr>\n".
    "<td bgcolor='#EEEEEE' width='40%'><font size='-2'><b>".CONTROL_CLASS_CLASS_TEMPLATE."</b></td>\n".
    "<td bgcolor='#EEEEEE' width='30%'><font size='-2'><b>".CONTROL_CONTENT_SUBDIVISION_FUNCS_SECTION."</b></td>\n".
    "<td bgcolor='#EEEEEE' width='30%'><font size='-2'><b>".CONTROL_CONTENT_SUBDIVISION_CLASS."</b></td>\n".
    "</tr>";

  $str = "";
  foreach ($Result as $row ) {

    if ($curClass != $row['ClassID']) {
      switch ($param_show) {
        case 0:
          print($str);
        break;
        case 1:
          if( $useSubClass ) print($str);
        break;
        case 2:
          if( !$useSubClass ) print($str);
        break;
      }

      //так сделано, чтобы для первого класса не выводился раздилитель
      $str = $divider;

      $str.= "<tr>";
      $divider = "<tr><td colspan='3' style='background:#CCCCCC; height:2px; padding:0px'></tr>";
      $curClass = $row['ClassID'];
      $useSubClass = false;
      if( $row['SubClassID']) $useSubClass = true;
        $str.= "<td bgcolor='#FFFFFF'>".
          "<a href='".$nc_core->ADMIN_PATH."class/index.php?phase=4&amp;ClassID=".$curClass."' style='text-decoration:none'>".
          "<font color='#000000'><b>".$curClass.". ".$row['ClassName']."</b></font></a>".
          "</td>";
      }
      else {
        $str.= "<tr><td bgcolor='#FFFFFF'><font size='-2'></font></td>";
      }

      if ( $row['SubID']) {
        $temp1 = "<a href='".$nc_core->ADMIN_PATH."subdivision/index.php?phase=5&amp;SubdivisionID=".$row['SubID']."' style='text-decoration:underline'>".$row['SubID'].". ".$row['SubName']."</a>";
        $temp2 = "<a href='".$nc_core->ADMIN_PATH."subdivision/SubClass.php?phase=3&amp;SubClassID=".$row['SubClassID']."&amp;SubdivisionID=".$row['SubID']."' style='text-decoration:underline'>".$row['SubClassID'].". ".$row['SubClassName']."</a>";
      }
      else {
        $temp1 = $temp2 = "—";
      }

      $str.= "<td bgcolor='#FFFFFF'><font size='-2'>".$temp1."</font></td>";
      $str.= "<td bgcolor='#FFFFFF'><font size='-2'>".$temp2."</font></td>";
      $str.= "</tr>";
    }

    switch ($param_show) {
      case 0:
        print($str);
      break;
      case 1:
        if( $useSubClass ) print($str);
      break;
      case 2:
        if( !$useSubClass ) print($str);
      break;
    }

    print "</table></td></tr></table>";
}


/**
 * Вывод формы для создания нового шаблона компонента
 *
 * @global object $db
 * @global object $UI_CONFIG
 *
 * @param int $class_id номер компонента, шаблон которого создается
 *
 * @return int 0
 */
function nc_classtemplate_preadd_from ( $class_id ) {
  global $db, $UI_CONFIG, $nc_core;

  $class_id = intval($class_id);

  // доступные типы шаблонов
  $types = array('useful',  'inside_admin', 'admin_mode', 'rss', 'xml');
  $exist_types = $db->get_col("SELECT DISTINCT `Type` FROM `Class` WHERE `ClassTemplate` ='".$class_id."' AND `Type` <> 'useful' ") ;
  if ( $exist_types ) $types = array_diff($types, $exist_types);

  // определение компонентов, на базе которых можно создать
  $class_name = $db->get_var("SELECT CONCAT(`Class_ID`, '. ', `Class_Name`) FROM `Class` WHERE `Class_ID` = '".$class_id."'");
  $base = array('auto'  => CONTROL_CLASS_COMPONENT_TEMPLATE_BASE_AUTO,
                'empty' => CONTROL_CLASS_COMPONENT_TEMPLATE_BASE_EMPTY);
  $base['class_'.$class_id] = $class_name;
  $templates = $db->get_results("SELECT `Class_ID` as `id`, CONCAT(`Class_ID`, '. ', `Class_Name`) as `name`
                                       FROM `Class` WHERE `ClassTemplate` = '".$class_id."'", ARRAY_A);
  if ( !empty($templates) ) foreach ( $templates as $k => $v ) {
    $base['class_'.$v['id']] = $v['name'];
  }

  echo "<fieldset><legend><b>".CONTROL_CLASS_COMPONENT_TEMPLATE_ADD_PARAMETRS."</b></legend>\r\n";
  echo "<form action='index.php' method='post'>\r\n ";

  // тип шаблона компонента
  echo CONTROL_CLASS_COMPONENT_TEMPLATE_TYPE_CLASSTEMPLATE.": <br/>\r\n";
  echo " <select name='Type' style='width: 250px;'>\r\n";
  foreach ( $types as  $v )
    echo "\t<option value='".$v."'>".constant("CONTROL_CLASS_COMPONENT_TEMPLATE_TYPE_".strtoupper($v))."</option>\r\n";
  echo "</select><br/><br/>\r\n";

  // на основе..
  echo CONTROL_CLASS_COMPONENT_TEMPLATE_CREATE_BASE.": <br/>\r\n";
  echo " <select name='base' style='width: 250px;'>\r\n";
  foreach ( $base as $k => $v )
    echo "\t<option value='".$k."'>".$v."</option>\r\n";
  echo "</select>\r\n";

  echo $nc_core->token->get_input();
  echo "<input type='hidden' name='phase' value='141' />\r\n";
  echo "<input type='hidden' name='ClassID' value='".$class_id."' />\r\n";
  echo "</form>\r\n";
  echo "</fieldset>\r\n";

  $UI_CONFIG->actionButtons[] = array(
      "id" => "submit",
      "caption" => CONTROL_CLASS_CLASS_TEMPLATE_ADD,
      "action" => "mainView.submitIframeForm()"
    );

  return 0;
}


/**
 * Создание шаблона компонента
 *
 * @param int $class_id номер исходного класса
 * @param string $type тип шаблона: useful, rss, admin_mode, inside_admin, xml
 * @param string $base создать на основе компонента - class_XX, auto, empty
 *
 * @return int номер созданого шаблона
 */
function nc_classtempalte_make ($class_id, $type='useful', $base = 'auto') {
  $nc_core = nc_Core::get_object();

  $class_id = intval($class_id);
  $class_name = $nc_core->component->get_by_id($class_id, 'Class_Name');
  
  if ( $type != 'useful' ) $class_name = constant("CONTROL_CLASS_COMPONENT_TEMPLATE_TYPE_".strtoupper($type));

  if ( $base == 'empty') {
    return $nc_core->component->add($class_name, CONTROL_CLASS_CLASS_TEMPLATE_GROUP, array(), $class_id, $type );
  }

  if ( $base == 'auto' && $type == 'rss') {
    $rss_template = nc_classtemplate_make_rss ( $class_id ); 
    $rss_template['ClassDescription'] = CONTROL_CLASS_COMPONENT_FOR_RSS;
    $rss_template['RecordsPerPage'] = 10;
    return $nc_core->component->add($class_name, CONTROL_CLASS_CLASS_TEMPLATE_GROUP, $rss_template, $class_id, NC_CLASS_TYPE_RSS );
  }

  if ( $base == 'auto' && $type == 'xml') {
    $rss_template = nc_classtemplate_make_xml ( $class_id );
    return $nc_core->component->add($class_name, CONTROL_CLASS_CLASS_TEMPLATE_GROUP, $rss_template, $class_id, 'xml' );
  }

  if ( $base == 'auto' && $type == 'inside_admin') {
    $rss_template = nc_classtemplate_make_inside_admin ( $class_id );
    return $nc_core->component->add($class_name, CONTROL_CLASS_CLASS_TEMPLATE_GROUP, $rss_template, $class_id, 'inside_admin' );
  }

  if ( $base == 'auto' && in_array($type, array('useful', 'admin_mode')) ) {
    $base  = 'class_'.$class_id;
  }

  // создание шаблона на основе другого компонента
  if ( preg_match('/class_(\d+)/i', $base, $match) ) {
    $class_template =  $nc_core->component->get_by_id($match[1]);
    return $nc_core->component->add($class_name, CONTROL_CLASS_CLASS_TEMPLATE_GROUP, $class_template, $class_id, $type );
  }

  
 

}

function nc_classtemplate_make_inside_admin ( $class_id ) {
  $nc_core = nc_Core::get_object();
  $prefix = "%Prefix% \r\n";
  $prefix .= '".( $searchForm ? "
    <div id=\'nc_admin_filter\'>
      <fieldset>
        <legend>".NETCAT_MODERATION_FILTER."</legend>
        $searchForm
      </fieldset>
    </div>
    " : "" )."';
  $record = "%Record%";
  $suffix = "%Suffix";
  $full = "%Full%";
  $settings = "%Settings%";
  $custom_settings = $nc_core->component->get_by_id($class_id, 'CustomSettingsTemplate');

  return array( 'FormPrefix' => $prefix, 'RecordTemplate' => $record, 'FormSuffix' => $suffix,
                'Settings' => $settings, 'RecordTemplateFull' => $full, 'CustomSettingsTemplate' => $custom_settings);
}

function nc_classtemplate_make_rss ( $class_id ) {
  $component = new nc_Component( $class_id );


  // поля, которые могут попасть в ленту
  $string_fields = $component->get_fields( NC_FIELDTYPE_STRING);
  $text_fields = $component->get_fields( NC_FIELDTYPE_TEXT);
  $date_fields = $component->get_fields( NC_FIELDTYPE_DATETIME );
  $file_fields = $component->get_fields( NC_FIELDTYPE_FILE );

  // префикс
  $prefix = '<?xml version=\\\"1.0\\\" encoding=\\\"".$nc_core->NC_CHARSET."\\\"?>
             <?xml-stylesheet type=\\\"text/xsl\\\\" href=\\\"/images/rss.xsl\\\"?>
             <rss version=\\\"2.0\\\" xml:lang=\\\"ru-RU\\\">
                <channel>
                  <title>".htmlspecialchars($system_env[\'ProjectName\'], ENT_QUOTES)."</title>
                  <link>http://".$_SERVER[\'HTTP_HOST\']."/</link>
                  <description>".htmlspecialchars(strip_tags($current_sub[\'Description\']), ENT_QUOTES)."</description>
                  <language>ru-RU</language>
                  <copyright>Copyright ".date("Y")." ".htmlspecialchars($system_env[\'ProjectName\'], ENT_QUOTES)."</copyright>
                  <lastBuildDate>".gmdate("D, d M Y H:i:s", $nc_last_update)." GMT</lastBuildDate>
                  <generator>CMS NetCat</generator>
                  <category>".htmlspecialchars(strip_tags($current_sub[\'Subdivision_Name\']), ENT_QUOTES)."</category>
                  <managingEditor>".$system_env[\'SpamFromEmail\']." (".htmlspecialchars($system_env[\'SpamFromName\'], ENT_QUOTES).")</managingEditor>
                  <webMaster>".$system_env[\'SpamFromEmail\']." (".htmlspecialchars($system_env[\'SpamFromName\'], ENT_QUOTES).")</webMaster>
                  <ttl>30</ttl>';

  // суффикс
  $suffix = '</channel>
             </rss>';

  // ищем поле для titl'a
  $title = "'".NETCAT_MODERATION_TITLE."'";
  if ( !empty($string_fields) ) foreach ( $string_fields as $v ) {
    if ( nc_preg_match('/(titl|caption|name|subject)/i', $v['name']) ) {
      $title = '$f_'.$v['name'];
      break;
    }
  }

  // ищем поле для description'a
  $description = "'".NETCAT_MODERATION_DESCRIPTION."'";
  if ( !empty($text_fields) ) foreach ($text_fields as $v ) {
    if ( nc_preg_match('/(text|message|announce|description|content)/i', $v['name']) ) {
      $description = '$f_'.$v['name'];
      break;
    }
  }

  // ищем поле для даты
  $pubDate = '$f_Created';
  if ( !empty($date_fields) ) foreach ($date_fields as $v ) {
    if ( nc_preg_match('/(date)/i', $v['name']) ) {
      $pubDate = '($f_'.$v['name'].' ? $f_'.$v['name'].' : $f_Created) ';
      break;
    }
  }
  
  // картинка
  $enclosure = "";
  if ( !empty($file_fields) ) foreach ($file_fields as $v ) {
      $enclosure .= '".( $f_'.$v['name'].'  ? "<enclosure url=\\\"http://".$_SERVER[\'HTTP_HOST\'].$f_'.$v['name'].'."\\\" length=\\\"$f_'.$v['name'].'_size\\\" type=\\\"$f_'.$v['name'].'_type\\\"  />" : "" )."';
      break;
  }


  

  // rss-элемент
  $record = '<item>
    <title>".htmlspecialchars('.$title.')."</title>
    <link>http://".$_SERVER[\'HTTP_HOST\']."$fullLink</link>
    <description>".'.$description.'."</description>
    <category>".htmlspecialchars($current_sub[\'Subdivision_Name\'])."</category>
    <pubDate>".date(DATE_RSS, strtotime('.$pubDate.') )."</pubDate>
    '.$enclosure.'
    <guid isPermaLink=\\\"true\\\">http://".$_SERVER[\'HTTP_HOST\']."$fullLink</guid>
  </item>';
  
  // системные настройки
  $settings = '$nc_last_update = $db->get_var("SELECT MAX(UNIX_TIMESTAMP(`Created`)) FROM `Message".$classID."` WHERE `Sub_Class_ID` = \'".$cc."\' AND `Checked` = 1 ");';
  $settings .= "\r\nheader(\"Content-type: text/xml; charset=\".\$nc_core->NC_CHARSET);";

  return array( 'FormPrefix' => $prefix, 'RecordTemplate' => $record, 'FormSuffix' => $suffix, 'Settings' => $settings);
}



function nc_classtemplate_make_xml ( $class_id ) {
  $component = new nc_Component( $class_id );

  // поля, которые могут попасть в ленту
  $fields = $component->get_fields( );

  // префикс
  $prefix = '<?xml version=\\\"1.0\\\" encoding=\\\"".$nc_core->NC_CHARSET."\\\"?>';
  $prefix .= "\r\n<messages>";

  $record = '<message id=\\\"".$f_RowID."\\\">'."\r\n";
  if ( !empty($fields) ) foreach ( $fields as $v ) {
    if ( in_array($v['type'], array(1,2,3,4, 5,7))) {
      $record .= "\t".'<'.strtolower($v['name']).'>".htmlspecialchars($f_'.$v['name'].')."</'.strtolower($v['name']).'>'."\r\n";
    }
    else if ( $v['type'] == 6 ) {
      $record .= "\t".'<'.strtolower($v['name']).'>".htmlspecialchars($f_'.$v['name'].'_name)."</'.strtolower($v['name']).'>'."\r\n";
    }
  }
  $record .= '</message>'."\r\n";

  $suffix = "</messages>\r\n";

  $settings = "ob_end_clean(); \r\nheader(\"Content-type: text/xml\");";
  return array( 'FormPrefix' => $prefix, 'RecordTemplate' => $record, 'FormSuffix' => $suffix, 'Settings' => $settings);
}


class ui_config_class extends ui_config {

  function ui_config_class($active_tab = 'edit', $class_id = 0, $class_group = '') {

    global $db, $nc_core, $MODULE_VARS;

    if ($class_id) {
    	$this->headerText = $db->get_var("SELECT Class_Name FROM Class WHERE Class_ID = $class_id");
    } elseif ($class_group) {
    	$this->headerText = $db->get_var("SELECT Class_Group FROM Class WHERE md5(Class_Group) = '".$class_group."' GROUP BY Class_Group");
    } else {
    	$this->headerText = SECTION_INDEX_DEV_CLASSES;
    }

    if ( in_array($active_tab, array('customadd', 'customedit', 'customsearch', 'customsubscribe', 'customdelete')) ) {
      $active_toolbar = $active_tab;
      $active_tab = 'classaction';
    }

    if ( $active_tab) $this->headerImage = 'i_folder_big.gif';

    if ($active_tab == 'add') {
	    $this->tabs = array(
	                     array('id' => 'add',
	                           'caption' => CONTROL_CLASS_ADD_ACTION,
	                           'location' => "dataclass.add($class_group)"));
    } elseif ($active_tab == 'addtemplate') {
	    $this->tabs = array(
	                     array('id' => 'addtemplate',
	                           'caption' => CONTROL_CLASS_CLASS_TEMPLATE_ADD,
	                           'location' => "dataclass.addtemplate(".$class_id.")"));
    } elseif ($active_tab == 'delete') {
	    $this->tabs = array(
	                     array('id' => 'delete',
	                           'caption' => CONTROL_CLASS_DELETE,
	                           'location' => "dataclass.delete($class_group)"));
    } else {
	    $this->tabs = array(
	                     array('id' => 'info',
	                           'caption' => CLASS_TAB_INFO,
	                           'location' => "dataclass.info($class_id)"),
	                     array('id' => 'edit',
	                           'caption' => CLASS_TAB_EDIT,
	                           'location' => "dataclass.edit($class_id)"),
	                     array('id' => 'classaction',
	                           'caption' => CLASS_TAB_CUSTOM_ACTION,
	                           'location' => "dataclass.classaction($class_id)"),
	                     array('id' => 'fields',
	                           'caption' => CONTROL_CLASS_FIELDS,
	                           'location' => "dataclass.fields($class_id)"));
    }

    // Активная вкладка - "Шаблоны действий"
    if ( $active_tab == 'classaction' ) {
      $this->toolbar = array (
                            array( 'id' => 'customadd',
	                                 'caption' => CLASS_TAB_CUSTOM_ADD,
	                                  'location' => "dataclass.customadd($class_id)",
	                                  'group' => "grp1"),

	                           array('id' => 'customedit',
	                                 'caption' => CLASS_TAB_CUSTOM_EDIT,
	                                 'location' => "dataclass.customedit($class_id)",
	                                 'group' => "grp1"),
	                           array('id' => 'customdelete',
	                                 'caption' => CLASS_TAB_CUSTOM_DELETE,
	                                 'location' => "dataclass.customdelete($class_id)",
	                                 'group' => "grp1"),
	                           array('id' => 'customsearch',
	                                 'caption' => CLASS_TAB_CUSTOM_SEARCH,
	                                 'location' => "dataclass.customsearch($class_id)",
	                                 'group' => "grp1") );
	     // действие "Подписка"
	     if ( $nc_core->modules->get_by_keyword('subscriber', 0)
            && ( !$MODULE_VARS['subscriber']['VERSION'] || $MODULE_VARS['subscriber']['VERSION'] == 1) ) {
	       $this->toolbar[] = array('id' => 'customsubscribe',
	                                'caption' => CLASS_TAB_CUSTOM_SUBSCRIBE,
	                                'location' => "dataclass.customsubscribe($class_id)",
	                                'group' => "grp1");
	     }
    }

    $this->activeTab = $active_tab;
    $this->activeToolbarButtons[] = $active_toolbar;

    if ($active_tab == 'add') {
    	$this->locationHash = "#dataclass.$active_tab($class_group)";
//	    $this->treeSelectedNode = "group-$class_group";
    }
    elseif ($active_tab == 'delete') {
      // иначе сбрасывается
    	//$this->locationHash = "#dataclass.".$active_tab."(".$class_id.")";
    }
    else {
      if ( $active_tab == 'classaction') {
    	  $this->locationHash = "#dataclass.$active_toolbar($class_id)";
      }
      else {
        $this->locationHash = "#dataclass.$active_tab($class_id)";
      }
        $this->treeSelectedNode = "dataclass-{$class_id}";
    }

    $this->treeMode = 'developer';
  }

  function updateTreeClassNode($class_id, $class_name) {

    $this->treeChanges['updateNode'][] = array("nodeId" => "sub-$node_id",
                                               "name" => "$node_id. $node_name");
  }

}

class ui_config_class_template extends ui_config {

  function ui_config_class_template ($active_tab = 'edit', $class_id = 0, $base_class = '') {

    global $db, $nc_core;

    $type = '';
    if ($class_id) {
    	$this->headerText = $db->get_var("SELECT `Class_Name` FROM `Class` WHERE `Class_ID` = '".$class_id."'");
      $type = $db->get_var("SELECT `Type` FROM `Class` WHERE `Class_ID` = '".$class_id."' ");
    }
    else {
    	$this->headerText = SECTION_INDEX_DEV_CLASS_TEMPLATES;
    }

    if ( in_array($active_tab, array('customadd', 'customedit', 'customsearch', 'customsubscribe', 'customdelete')) ) {
      $active_toolbar = $active_tab;
      $active_tab = 'classaction';
    }

    if ( $active_tab) $this->headerImage = 'i_folder_big.gif';

    if ($active_tab == 'add') {
	    $this->tabs = array(
        array(
          'id' => 'add',
          'caption' => CONTROL_CLASS_CLASS_TEMPLATE_ADD,
          'location' => "classtemplate.add(".$base_class.")"
        )
      );
    }
    elseif ($active_tab == 'delete') {
	    $this->tabs = array(
        array(
          'id' => 'delete',
          'caption' => CLASS_TEMPLATE_TAB_DELETE,
          'location' => "classtemplate.delete(".$class_id.($base_class ? ",".$base_class : "").")"
        )
      );
    }
    else {
	    $this->tabs = array(
        array(
          'id' => 'edit',
          'caption' => CLASS_TEMPLATE_TAB_EDIT,
          'location' => "classtemplate.edit(".$class_id.")"
        ));

      if (  $type != 'rss' && $type != 'xml')
        $this->tabs[] = array(
          'id' => 'classaction',
          'caption' => CLASS_TAB_CUSTOM_ACTION,
          'location' => "classtemplate.classaction(".$class_id.")"
        );
      
    }

    // Активная вкладка - "Шаблоны действий"
    if ( $active_tab == 'classaction' ) {
      $this->toolbar = array (
        array(
          'id' => 'customadd',
          'caption' => CLASS_TAB_CUSTOM_ADD,
          'location' => "classtemplate.customadd(".$class_id.")",
          'group' => "grp1"
        ),
        array(
          'id' => 'customedit',
          'caption' => CLASS_TAB_CUSTOM_EDIT,
          'location' => "classtemplate.customedit(".$class_id.")",
          'group' => "grp1"
        ),
        array(
          'id' => 'customdelete',
          'caption' => CLASS_TAB_CUSTOM_DELETE,
          'location' => "classtemplate.customdelete(".$class_id.")",
          'group' => "grp1"
        ),
        array(
          'id' => 'customsearch',
          'caption' => CLASS_TAB_CUSTOM_SEARCH,
          'location' => "classtemplate.customsearch(".$class_id.")",
          'group' => "grp1"
        )
      );
      // действие "Подписка"
      if ( $nc_core->modules->get_by_keyword('subscriber', 0) ) {
        $this->toolbar[] = array(
          'id' => 'customsubscribe',
          'caption' => CLASS_TAB_CUSTOM_SUBSCRIBE,
          'location' => "classtemplate.customsubscribe(".$class_id.")",
          'group' => "grp1"
        );
      }
    }

    $this->activeTab = $active_tab;
    $this->activeToolbarButtons[] = $active_toolbar;

    if ($active_tab == 'add') {
    	$this->locationHash = "#classtemplate.".$active_tab."(".$base_class.")";
    }
    elseif ($active_tab == 'delete') {
      // иначе сбрасывается
      //$this->locationHash = "#classtemplate.".$active_tab."(".$class_id.($base_class ? ",".$base_class : "").")";
    }
    else {
      if ( $active_tab == 'classaction') {
    	  $this->locationHash = "#classtemplate.".$active_toolbar."(".$class_id.")";
      }
      else {
        $this->locationHash = "#classtemplate.".$active_tab."(".$class_id.")";
      }
      $this->treeSelectedNode = "classtemplate-".$class_id;
    }

    $this->treeMode = 'developer';
  }

  function updateTreeClassNode($class_id, $class_name) {

    $this->treeChanges['updateNode'][] = array(
      "nodeId" => "sub-".$node_id,
      "name" => $node_id.". ".$node_name
    );
  }

}

class ui_config_class_templates extends ui_config {

  function ui_config_class_templates($active_tab = 'edit', $class_id) {

    $this->headerText = CONTROL_CLASS_CLASS_TEMPLATES;
    $this->headerImage = 'i_folder_big.gif';
    $this->tabs = array(
      array(
        'id' => 'edit',
        'caption' => CONTROL_CLASS_CLASS_TEMPLATES,
        'location' => "classtemplates.edit(".$class_id.")"
      )
    );

    $this->activeTab = $active_tab;
    $this->locationHash = "classtemplates.edit(".$class_id.")";
    $this->treeMode = 'developer';
    $this->treeSelectedNode = "classtemplates-".$class_id;
  }
}

class ui_config_class_group extends ui_config {

  function ui_config_class_group($active_tab = 'edit', $class_group) {

    global $db;

    $this->headerText = $db->get_var("SELECT Class_Group FROM Class WHERE md5(Class_Group) = '$class_group' GROUP BY Class_Group");
    $this->headerImage = 'i_folder_big.gif';
    $this->tabs = array(
	                 array('id' => 'edit',
                           'caption' => CONTROL_CLASS_CLASS_GROUPS,
                           'location' => "classgroup.edit($class_group)")
	          );

    $this->activeTab = $active_tab;
    $this->locationHash = "classgroup.edit($class_group)";
    $this->treeMode = 'developer';
    $this->treeSelectedNode = "group-$class_group";
  }
}

class ui_config_classes extends ui_config {

  function ui_config_classes($active_tab = 'dataclass.list') {

    $this->headerText = SECTION_CONTROL_CLASS;
    $this->headerImage = 'i_folder_big.gif';
    $this->tabs = array(
	                 array('id' => 'dataclass.list',
                           'caption' => SECTION_CONTROL_CLASS_LIST,
                           'location' => "dataclass.list()")
	          );
    $this->activeTab = $active_tab;

	$this->locationHash = "#dataclass.list()";
    $this->treeMode = 'developer';
    $this->treeSelectedNode = "dataclass.list()";
  }
}

class ui_config_system_class extends ui_config {

  function ui_config_system_class($active_tab = 'edit', $system_class_id) {

    global $db, $nc_core;

    $system_class = $db->get_row("SELECT a.System_Table_ID, a.System_Table_Rus_Name, b.Class_ID, IF(b.AddTemplate<>'' OR b.AddCond<>'' OR b.AddActionTemplate<>'',1,0) AS IsAdd, IF(b.EditTemplate<>'' OR b.EditCond<>'' OR b.EditActionTemplate<>'' OR b.CheckActionTemplate<>'' OR b.DeleteActionTemplate<>'',1,0) AS IsEdit, IF(b.SearchTemplate<>'' OR b.FullSearchTemplate<>'',1,0) AS IsSearch, IF(b.SubscribeTemplate<>'' OR b.SubscribeCond<>'',1,0) AS IsSubscribe FROM System_Table AS a LEFT JOIN Class AS b ON a.System_Table_ID=b.System_Table_ID WHERE a.System_Table_ID = '".$system_class_id."'", ARRAY_A);

    $this->headerText = constant($system_class["System_Table_Rus_Name"]);
    $this->headerImage = 'i_folder_big.gif';

    if ($system_class["Class_ID"] || $system_class[System_Table_ID]) {
      if ($system_class_id == 3 && $nc_core->modules->get_by_keyword('auth', 0) ) {
    	$this->tabs[] = array('id' => 'edit',
        	                  'caption' => CLASS_TAB_EDIT,
            	              'location' => "systemclass.edit($system_class[System_Table_ID])");
	    $this->tabs[] = array('id' => 'customadd',
	                          'caption' => CLASS_TAB_CUSTOM_ADD,
	                          'location' => "systemclass.customadd($system_class[System_Table_ID])");
	    $this->tabs[] = array('id' => 'customedit',
	                          'caption' => CLASS_TAB_CUSTOM_EDIT,
	                          'location' => "systemclass.customedit($system_class[System_Table_ID])");
	    $this->tabs[] = array('id' => 'customsearch',
	                          'caption' => CLASS_TAB_CUSTOM_SEARCH,
	                          'location' => "systemclass.customsearch($system_class[System_Table_ID])");
      }
	  $this->tabs[] = array('id' => 'fields',
	                        'caption' => CONTROL_CLASS_FIELDS,
	                        'location' => "systemclass.fields($system_class[System_Table_ID])");
	}
    $this->activeTab = $active_tab;
    $this->locationHash = "#systemclass.$active_tab($system_class[System_Table_ID])";

    $this->treeMode = 'developer';
    $this->treeSelectedNode = "systemclass-{$system_class[System_Table_ID]}";
  }
}

class ui_config_system_classes extends ui_config {

  function ui_config_system_classes($active_tab = 'systemclass.list') {

    $this->headerText = SECTION_CONTROL_CLASS;
    $this->headerImage = 'i_folder_big.gif';
    $this->tabs = array(
	                 array('id' => 'systemclass.list',
                           'caption' => SECTION_SECTIONS_OPTIONS_SYSTEM,
                           'location' => "systemclass.list")
	          );
    $this->activeTab = $active_tab;

    $this->treeMode = 'developer';
    $this->treeSelectedNode = "systemclass.list";
  }
}

function print_bind() {
  print "
  <!-- Binding event_handlers to textarea resize link -->
  <script>
    (function (){
      var links = document.getElementsByTagName('A');
      var onclicker_grow   = function (event) { ShrinkArea(event, 50);  }
      var onclicker_shrink = function (event) { ShrinkArea(event,-50);  }
      for (var i = 0 ; i < links.length ; i++){
          if (links[i].className.search('textarea_shrink') != -1 ) {
            bindEvent(links[i], 'click', onclicker_grow );
      }
          if (links[i].className.search('textarea_grow') != -1 ) {
            bindEvent(links[i], 'click', onclicker_shrink);
          }
      }
    }) ();
  </script>
  ";
}
function print_resizeblock($textarea_id){
  print "<div class='resize_block'> <a class='textarea_shrink' href='#".$textarea_id."' > &#x25BC; </a><a class='textarea_grow' href='#".$textarea_id."'> &#x25B2; </a></div>";
}
?>
