<?php
/* $Id: message_fields.php 4079 2010-10-22 13:10:24Z denis $ */

if ( !class_exists("nc_System") ) die("Unable to load file.");

if($user_table_mode) $systemTableName = "User";

if($f_Keyword && $admin_mode) {
	$isDuplicatedKeyword = $db->get_var("SELECT COUNT(*)
		 FROM `".($user_table_mode || $systemTableID ? "User" : "Message".$classID)."`
		 WHERE `Keyword` = '".$f_Keyword."'
		 ".($user_table_mode || $systemTableID ? "" : " AND `Subdivision_ID` = '".$sub."'")."
		 ".($action=="change" ? " AND `".($user_table_mode || $systemTableID ? "User" : "Message")."_ID` <> '".$message."'" : "") );

	if(!$isDuplicatedKeyword && !$user_table_mode) {
		$isDuplicatedKeyword = $db->get_var("SELECT COUNT(*) FROM `Sub_Class`
			WHERE `EnglishName` = '".$f_Keyword."' AND `Subdivision_ID` = '".$sub."'");
	}
}
else {
	$isDuplicatedKeyword = false;
}


$res = $db->get_results("SELECT `Field_ID`,
	`Field_Name`,
	`Description`,
	`TypeOfData_ID`,
	`Format`,
	`NotNull`,
	`Inheritance`,
	`DefaultState`,
	`TypeOfEdit_ID`,
	".($systemTableID ? "1 AS `DoSearch`" : "`DoSearch`")."
	FROM `Field`
	WHERE ".($systemTableID ? "`System_Table_ID` = ".$systemTableID : "`Class_ID` = ".$classID)."
	ORDER BY `Priority`", ARRAY_N);

$fldCount = $db->num_rows;
$i = 0;
// "старые" значения полей типа "файл". Нужно иметь возможность откатиться назад
// при posting = 0
$old_file_values = array();
// файлы, которые были помечены к удалению
$file_to_delete = array();

if( !empty($res) ) {
	foreach($res AS $value) {
    // OpenID
    if ($value[3]==11 && $action=='change') {
      $fldCount--;
      continue; 
    }
  
		// possibly there are no additional fields
		list($fldID[$i], $fld[$i], $fldName[$i], $fldType[$i], $fldFmt[$i], $fldNotNull[$i], $fldInheritance[$i], $fldDefault[$i], $fldTypeOfEdit[$i], $fldDoSearch[$i]) = $value;
    eval ("\$checkKillFile = \$f_KILL".$fldID[$i].";");

		if ($checkKillFile && $action=="change" && $message && $posting) {
			// delete old & new types of file if checked Delete when change
      $file_to_delete[] = $i;
		}
    //MultiSelect
    if ( $fldType[$i] == 10) { 
      eval("\$fldValue[\$i] = \$f_".$fld[$i].";");
    }
    else if ( $fldType[$i] != 6 )  {
      eval("\$fldValue[\$i] = trim((is_array(\$f_".$fld[$i].")?\$_FILES['f_".$fld[$i]."']['tmp_name']:stripslashes(\$f_".$fld[$i].")));");
    }
      
		if ($fldType[$i]==8) {
			eval("if (\$f_".$fld[$i]."_day || \$f_".$fld[$i]."_month || \$f_".$fld[$i]."_year || \$f_".$fld[$i]."_hours || \$f_".$fld[$i]."_minutes || \$f_".$fld[$i]."_seconds) \$fldValue[\$i] = sprintf(\"%04d-%02d-%02d %02d:%02d:%02d\",\$f_".$fld[$i]."_year,\$f_".$fld[$i]."_month,\$f_".$fld[$i]."_day,\$f_".$fld[$i]."_hours,\$f_".$fld[$i]."_minutes,\$f_".$fld[$i]."_seconds);");
		}
		
	
	$i++;
	}
}

# текст сообщений об ошибке
$errDescr[1] = NETCAT_MODERATION_MSG_ONE;
$errDescr[2] = NETCAT_MODERATION_MSG_TWO;
$errDescr[6] = NETCAT_MODERATION_MSG_SIX;
$errDescr[7] = NETCAT_MODERATION_MSG_SEVEN;
$errDescr[8] = NETCAT_MODERATION_MSG_EIGHT;
$errDescr[21] = NETCAT_MODERATION_MSG_TWENTYONE;

if($isDuplicatedKeyword && $posting) {
	$posting = 0;
	$errCode = 21;
	$warnText = $errDescr[$errCode];
}

if(nc_strlen($f_Keyword) > 0 && $posting) {
	if( !nc_preg_match("/^[a-zа-я0-9\-_]+$/i", $f_Keyword) ) {
		$posting = 0;
		$errCode = 21;
		$warnText = $errDescr[$errCode];
	}
}

if($posting) {
	for($i=0; $i<$fldCount; $i++) {

		$errCode = 0;
		switch ($fldType[$i]) {
			# string
		  case NC_FIELDTYPE_STRING:
				if ($fldNotNull[$i] && $fldValue[$i]=="" && !($action=='change' && $fld[$i]==$AUTHORIZE_BY)) $errCode = 1;
				if ($fldNotNull[$i] && $fldFmt[$i]=="url" && ($fldValue[$i]=='http://' || $fldValue[$i]=='ftp://')) $errCode = 1;
				if ($fldFmt[$i]=="email" && $fldValue[$i] && !nc_preg_match("/^[a-z0-9\._-]+@[a-z0-9\._-]+\.[a-z]{2,6}$/i", $fldValue[$i])) $errCode = 2;
				if ($fldFmt[$i]=="phone" && $fldValue[$i] && !nc_preg_match("/^ (\+?\d-?)?  (((\(\d{3}\))|(\d{3})?)-?)?  \d{3}-?\d{2}-?\d{2} $/x",  str_replace(array(" ", " \t"), '', $fldValue[$i]))) $errCode = 2;
				if ($fldType[$i]==1 && $fldFmt[$i]=="url" && ($fldValue[$i]=='http://' || $fldValue[$i]=='ftp://')) $fldValue[$i] = "";
				if ($fldFmt[$i]=="url" && $fldValue[$i] && !isURL($fldValue[$i])) $errCode = 2;
			break;
      
			# int 
			case NC_FIELDTYPE_INT:
				if ($fldNotNull[$i] && $fldValue[$i]=="") $errCode = 1;
				if ($fldValue[$i]!="" && $fldValue[$i] != strval(intval($fldValue[$i]))) $errCode = 2;
			break;
      
			# text
			case NC_FIELDTYPE_TEXT:
				if ($fldNotNull[$i] && $fldValue[$i]=="") $errCode = 1;
			break;
      
			# select
			case NC_FIELDTYPE_SELECT:
			  global $db;
				if($fldNotNull[$i] && !$fldValue[$i]) $errCode = 1;
				if($fldValue[$i]!="") $fldValue[$i]+=0;
				
				$var_name =     "f_".$fld[$i]."_name";
				$var_name_id =  "f_".$fld[$i]."_id";
				if ($fldValue[$i]) 
				  $$var_name = $db->get_var("SELECT `".$fldFmt[$i]."_Name`
				                             FROM   `Classificator_".$fldFmt[$i]."` 
				                             WHERE  `".$fldFmt[$i]."_ID`='".$fldValue[$i]."'");
				$$var_name_id = $fldValue[$i];
			break; 
      
			#bool
			case NC_FIELDTYPE_BOOLEAN:
				# если "checkbox"
				if($fldNotNull[$i] && $fldValue[$i]=="") $fldValue[$i] = 0;
				# если есть значение и оно не "1" и не "NULL", то 1
				if($fldValue[$i] && !is_int($fldValue[$i]) && $fldValue[$i]!="NULL") $fldValue[$i] = 1;
				# если значение "NULL" и по умолчанию "1"
				if($fldDefault[$i] && $fldValue[$i]=="NULL") $fldValue[$i] = 1;
			break;

			# file
			case  NC_FIELDTYPE_FILE:
        eval("\$fldValue[\$i] = trim((is_array(\$f_".$fld[$i].")?\$_FILES['f_".$fld[$i]."']['tmp_name']:stripslashes(\$f_".$fld[$i].")));");
				if($action=="change") {
					$oldValue = "f_".$fld[$i]."_old";
					$oldValue = $$oldValue;
          $old_file_values[$i] = $oldValue;
					if ($oldValue && ($fldValue[$i]=="" || $fldValue[$i]=="none")) $fldValue[$i] = $oldValue;
				}

				if($fldNotNull[$i] && ($fldValue[$i]=="" || $fldValue[$i]=="none")) $errCode = 6;
				if($fldValue[$i] && $fldValue[$i]!="none" && !$oldValue && (!file_exists($fldValue[$i]) || !@filesize($fldValue[$i]))) $errCode = 2;

				if($fldValue[$i] && $fldValue[$i]!="none" && is_uploaded_file($fldValue[$i])) {
					// формат поля
				  $parsedFormat = nc_field_parse_format($fldFmt[$i], NC_FIELDTYPE_FILE);
				  // тип файловой системы
				  $fldFS[$i] = $parsedFormat['fs'];
				  // закачиваемый файл?
				  $fldDisposition[$i] = $parsedFormat['disposition'] ? 1 : 0;
				  //$fileSettings = explode(":",$fldFmt[$i]);
					$filetype = $_FILES["f_".$fld[$i]]['type'];
					$filesize = $_FILES["f_".$fld[$i]]['size'];
          // Проверка размера файла
          if ( $parsedFormat['size'] > 0 && ($filesize >  $parsedFormat['size']) ) $errCode = 7;
          
          //Проверка на тип файла
          if ( !empty($parsedFormat['type'])) {
            $filetypeNotAllowed = true; // подходит тип или нет
            $filetypeParsed = explode("/", $filetype);
        
            foreach ( $parsedFormat['type'] as $v ) {
              if ( $filetypeParsed[0] != $v[0] ) continue;
              if ($filetypeParsed[1] == $v[1] || $v[1] == '*' ) {
                $filetypeNotAllowed = false; // файл подходит по типу
                break;   
              }
            }
            
            if ( $filetypeNotAllowed ) $errCode = 8;
          }

				} 

				if($errCode) $fldValue[$i] = $oldValue;
			break;

			#float
			case NC_FIELDTYPE_FLOAT:
				if ($fldNotNull[$i] && $fldValue[$i]=="") $errCode = 1;
				if ( $fldValue[$i]!="" && !preg_match("/^\-?[0-9]+(\.[0-9]+)?$/is", str_replace(",", ".", $fldValue[$i]) ) ) $errCode = 2;
        if ( preg_match("/,/is", $fldValue[$i]) ) $fldValue[$i] = str_replace(",", ".", $fldValue[$i]);
				
			break;
      
			#datetime
			case NC_FIELDTYPE_DATETIME:
				if($fldNotNull[$i] && $fldValue[$i]=="") $errCode = 1;
				if($fldValue[$i]!="" && $fldValue[$i]!='0000-00-00 00:00:00' && $fldFmt[$i] != 'event_time' && !checkdate(nc_substr($fldValue[$i],5,2),nc_substr($fldValue[$i],8,2), nc_substr($fldValue[$i],0,4))) {
					$errCode = 2;
					$fldValue[$i] = "";
				}
			break;
      
			#relation
			case NC_FIELDTYPE_RELATION:
				if($fldValue[$i]) $fldValue[$i] = (int)$fldValue[$i];
				if($fldNotNull[$i] && !$fldValue[$i]) $errCode = 1;
			break;
      
			#multiselect
      case NC_FIELDTYPE_MULTISELECT:
				if($fldNotNull[$i] && !count($fldValue[$i])) $errCode = 1;
				$ClassificatorName = strtok($fldFmt[$i], ':');
        $tmp = ",";  
        $var_name =     "f_".$fld[$i]."_name";
				$var_name_id =  "f_".$fld[$i]."_id";
				
				if ( !empty($fldValue[$i]) ) {
          foreach ( $fldValue[$i] as $v ) { 
            $tmp .=$v.",";
            ${$var_name_id}[] = $v;
          }
          $fldValue[$i] = $tmp;
  
  				if (!empty($$var_name_id)) 
  				  $$var_name = $db->get_col("SELECT `".$ClassificatorName."_Name`
  				                             FROM   `Classificator_".strtok($fldFmt[$i], ':')."` 
  				                             WHERE  `".$ClassificatorName."_ID` IN (".join(',', $$var_name_id).")");
				}
				else {
				  $fldValue[$i] = "";
				  $$var_name = array();  
				}
				
        unset($ClassificatorName);
			break;


		}

		if($user_table_mode) { 
			// проверка на уникальность поля, по которму идет авторизация
		  if( $fld[$i]==$AUTHORIZE_BY && CheckLoginIfExist($fldValue[$i], $action == 'add' ? 0 : $message, $db) ) {
		    $warnText = sprintf(NETCAT_MODERATION_MSG_LOGINALREADY."<br>", $fldValue[$i]);
				$posting = 0;
				break;
			}
      
			// проверка пароля
			if ( $action == 'add') {
			  if($Password1!=$Password2 || !$Password1) {
				  $warnText = NETCAT_MODERATION_MSG_RETRYPASS."<br>";
				  $posting = 0;
				  break;
			  }
			  else {
			    $Password = $Password1;
			  }
			}
		}

		switch ($fldTypeOfEdit[$i]) {
			case 1:
				$warnUser = true;
			break;
			case 2:
				$warnUser = $admin_mode;
			break;
			case 3:
				$warnUser = false;
			break;
		}

		if($warnUser && $errCode) {
			$warnText = $errDescr[$errCode];
			$warnText = str_replace("%NAME", $fldName[$i], $warnText);
			$posting = 0;
			break;
		}
	}

	# проверка изображения на картинке
	if(  !$AUTH_USER_ID && $action=="add" && $current_cc["UseCaptcha"] && $MODULE_VARS["captcha"] && function_exists("imagegif") ) {
		if( !nc_captcha_verify_code($nc_captcha_code) ) {
			$warnText = NETCAT_MODULE_CAPTCHA_WRONG_CODE;
			$posting = 0;
		}
	}

  // обертка для вывода ошибки в админке
	if($warnText && $nc_core->inside_admin) {
		$warnText = "<div class='status_error'>".$warnText."</div>";
	}

  // в случае ошибки нужно сохранить предыдущие значения полей типа файл
  if ( !$posting && !empty($old_file_values) ) {
    foreach ( $old_file_values as $k => $v) {
      $fldValue[$k] = $v;
    }
  }

  // ошибок при заполнении формы нет - можно удалть файлы
  if ( $posting && !empty($file_to_delete) ) {
    foreach ( $file_to_delete as $v ) {
      DeleteFile($fldID[$v], $fld[$v], $classID, $systemTableName, $message);
    }
  }

  unset($old_file_values);
  unset($file_to_delete);
}

?>